import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

public class CSVFilter extends FileFilter {
    final static String csv = "csv";
    
    public boolean accept(File f) {
	    if (f.isDirectory()) {
	        return true;
	    }

	    String s = f.getName();
	    int i = s.lastIndexOf('.');

	    if (i > 0 &&  i < s.length() - 1) {
	        String extension = s.substring(i+1).toLowerCase();
	        if (csv.equals(extension)) {
		        return true;
	        } else {
		        return false;
	        }
	    }
	    return false;
    }
    
    // The description of this filter
    // References:
    // http://whatis.techtarget.com/definition/0,,sid9_gci213871,00.html
    public String getDescription() {
	    return "Comma-separated values";
    }
}/* END CLASS CSVFilter() */
