/************************************************************************************/
/* file - CheckBoxRender.java                                                       */
/* --------------------------                                                       */
/* This file implements the Swing graphical render for producing a table cell that  */
/* with a checkbox instead of text.                                                 */
/* --------------------------                                                       */
/* NIST Self-Assessment Tool                                                        */
/* Author - Mark McLarnon                                                           */
/************************************************************************************/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.util.EventObject;

class CheckBoxRenderer extends JCheckBox implements TableCellRenderer {

    public CheckBoxRenderer() {
        setHorizontalAlignment(JLabel.CENTER);
    }
  
    public Component getTableCellRendererComponent(JTable table, Object value,
                         boolean isSelected, boolean hasFocus,
                          int row, int column) {
        if (isSelected) {
            setForeground(table.getSelectionForeground());
            setBackground(table.getSelectionBackground());
        }else {
            setForeground(table.getForeground());
            setBackground(table.getBackground());
        }
        setSelected((value != null && ((Boolean)value).booleanValue()));        
        return this;
    }

}/* end class CheckboxRenderer() */
