import javax.swing.*;
import javax.swing.event.*;
import java.io.*;

public class ChooseBrowserWizard extends JFrame {

    ASSET parent = null;
    ASSETPropertyManager props = null;
    JFileChooser browser_chooser = new JFileChooser();
    File browser_target = null;
    
    public ChooseBrowserWizard() {
        this.setVisible(false);  
        this.browser_chooser.addChoosableFileFilter(new EXEFilter());
    }
    
    public ChooseBrowserWizard(ASSET parent, ASSETPropertyManager props) {
        this.setVisible(false);
        this.parent = parent;
        this.props = props;
        this.browser_chooser.addChoosableFileFilter(new EXEFilter());
        this.browser_chooser.setDialogTitle("Choose Your Default Web Browser");
        this.start();
    }
    
    public static ChooseBrowserWizard spawnNewChooseBrowserWizard(ASSET parent, ASSETPropertyManager props) {
        return new ChooseBrowserWizard(parent, props);    
    }
    
    public void setBrowserTarget(File target) {
        if (target.exists()) {
            this.browser_target = target;
        }else {
            {
                this.parent.displayErrorDialog("This file seems not to exist, please try again!");    
            }
            this.start();
        }
    }
    
    public void start() {
        try {
	        int reply = JOptionPane.showConfirmDialog(this, 
	    	                                  "In order to view the ASSET help files you must choose your default web\nbrowser. Would you like to do this now?", 
	    	                                  "Choose default web browser" , 
	    	                                  JOptionPane.YES_NO_OPTION, 
	    	                                  JOptionPane.QUESTION_MESSAGE);
            if (reply == JOptionPane.YES_OPTION) {
                int response = this.browser_chooser.showOpenDialog(this);
                
                if (response == this.browser_chooser.APPROVE_OPTION) {
                    this.setBrowserTarget(this.browser_chooser.getSelectedFile());
                    if (this.props.addProperty("sat.help.defaultbrowser", this.browser_target.toString())) {
                        {
                            this.parent.displayStatusDialog("Your default browser has been stored successfully!");
                        }
                        this.dispose();
                    }
                }else if (response == this.browser_chooser.CANCEL_OPTION) {
                    {
                        this.parent.displayStatusDialog("You will keep recieving this message unless you have already specified your default browser\nor until you specify a default web browser.");    
                    }
                    this.dispose();                    
                }
            }else if (reply == JOptionPane.NO_OPTION) {
                {
                    this.parent.displayStatusDialog("You will keep recieving this message unless\nyou have already specified your default browser or\nuntil you specify a default web browser.");    
                }
                this.dispose();
            }
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
    
}/* end class ChooseBrowserWizard() */