import javax.swing.*;
import java.awt.*;

public class HTMLLabel extends JLabel {
    
    public HTMLLabel() {
        try {
            this.html_src.append(this.html_src_begin);
            this.html_src.append(this.html_src_end);
        }catch (Exception e) {
            e.printStackTrace();    
        }
    }
    
    public HTMLLabel(String value) {
        try {
            this.setLabelValue(value);            
            this.html_src.append(this.html_src_begin);
            this.html_src.append(this.getLabelValue());
            this.html_src.append(this.html_src_end);
            this.setText(this.html_src.toString());
        }catch (Exception e) {
            e.printStackTrace();    
        }
    }
    
    public static HTMLLabel createNewHTMLLabel(String label_value) {
        return new HTMLLabel(label_value); 
    }

	// This method is designed to encapsulate changing the cursor type
	// it is used to show the user that an action is occurring that needs 
	// to pause for.
	private void internal_setCursor(String cursor_type) {
	    try {
	        if (cursor_type.equals("wait")) {
                this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.WAIT_CURSOR));
	        }else  if (cursor_type.equals("hand")) {
	            this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
	        }else  if (cursor_type.equals("default")) {
	            this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
	        }
	    }catch (Exception e) {
            e.printStackTrace();
	    }
	}    
    
    public String getPlainText() {
        return this.getLabelValue();    
    }
    
    public void setHTMLText(String txt) {
        try {
            this.setLabelValue(txt);
            this.html_src = new StringBuffer("");
            this.html_src.append(this.html_src_begin);
            this.html_src.append(this.getLabelValue());
            this.html_src.append(this.html_src_end);
            this.setText(this.html_src.toString());
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void rollover_enter() {
        try {
            this.html_src = new StringBuffer("");
            this.internal_setCursor("hand");
            this.html_src.append(this.html_src_begin);
            this.html_src.append("<font color=\"#0033FF\" size=\"2\" face=\"Arial, Helvetica, sans-serif\"><b><u>");
            this.html_src.append(this.getLabelValue());
            this.html_src.append("</u></b></font>");
            this.html_src.append(this.html_src_end);
            this.setText(this.html_src.toString());
        }catch (Exception e) {
            e.printStackTrace();
        }        
    }
    
    public void rollover_exit() {
        try {
            this.internal_setCursor("default");
            this.html_src = new StringBuffer("");
            this.html_src.append(this.html_src_begin);
            this.html_src.append("<font color=\"#000000\" size=\"2\" face=\"Arial, Helvetica, sans-serif\">");
            this.html_src.append(this.getLabelValue());
            this.html_src.append("</font>");            
            this.html_src.append(this.html_src_end);
            this.setText(this.html_src.toString());
        }catch (Exception e) {
            e.printStackTrace();
        }        
    }
    
    private String getLabelValue() {
        return this.label_value;    
    }
    
    public void setLabelValue(String value) {
        this.label_value = value;   
    }
    
    private String html_src_begin  = "<html><body text=\"#000000\"><font color=\"#000000\" size=\"2\" face=\"Arial, Helvetica, sans-serif\">";
    private String html_src_end    = "</font></body></html>";
    private String label_value = "";
    
    private StringBuffer html_src = new StringBuffer("");
    
}/* end class HTMLabel() */