/************************************************************************************/
/* file - saveLogDialog.java                                                        */
/* -------------------------                                                        */
/* This class saves the current log from LogWindow class to a zipped outfile        */
/* -------------------------                                                        */
/* NIST Self-Assessment Tool                                                        */
/* Author - Mark McLarnon                                                           */
/* -------------------------                                                        */
/* Change Control:                                                                  */
/* 02/13/02 - Added code to center dialog on screen upon open                       */
/* 02/14/02 - Added current directory to beginning of File instances                */
/************************************************************************************/
import java.awt.datatransfer.*;
import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
import java.util.zip.*;
import com.symantec.itools.javax.swing.icons.ImageIcon;
import com.symantec.itools.javax.swing.models.StringTableModel;
import com.symantec.itools.javax.swing.actions.JActionMenuItem;

public class saveLogDialog extends javax.swing.JDialog {
    
	public saveLogDialog(Frame parent) {
		super(parent);
		
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("Save SAT Log");
		setResizable(false);
		getContentPane().setLayout(null);
		setSize(406,212);
		setVisible(false);
		save_button.setText("Save");
		save_button.setActionCommand("Save");
		save_button.setMnemonic((int)'S');
		getContentPane().add(save_button);
		save_button.setBounds(312,148,84,26);
		file_name_field.setNextFocusableComponent(save_button);
		file_name_field.setToolTipText("Shows the filename of the log you are about to save");
		getContentPane().add(file_name_field);
		file_name_field.setBounds(84,156,216,26);
		try {
			saveIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/save.gif"));
		}catch (java.net.MalformedURLException error) { 
		    ;
		}
		//$$ saveIcon.move(0,216);
		JLabel1.setText("File Name:");
		getContentPane().add(JLabel1);
		JLabel1.setBounds(12,156,60,24);
		getContentPane().add(JTabbedPane1);
		JTabbedPane1.setBounds(0,0,396,144);
		JScrollPane1.setOpaque(true);
		JTabbedPane1.add(JScrollPane1);
		JScrollPane1.setBounds(2,24,391,117);
		JScrollPane1.setVisible(false);
		save_table.setModel(saved_logs_model);
		JScrollPane1.getViewport().add(save_table);
		save_table.setBounds(0,0,388,0);
		JScrollPane2.setOpaque(true);
		JTabbedPane1.add(JScrollPane2);
		JScrollPane2.setBounds(2,24,391,117);
		JScrollPane2.setVisible(false);
		unzipped_save_table.setModel(unzippedSaveModel);
		JScrollPane2.getViewport().add(unzipped_save_table);
		unzipped_save_table.setBounds(0,0,388,0);
		JTabbedPane1.setSelectedIndex(0);
		JTabbedPane1.setSelectedComponent(JScrollPane1);
		JTabbedPane1.setTitleAt(0,"Compressed Logs");
		JTabbedPane1.setTitleAt(1,"Uncompressed Logs");
		compressed_radio_choice.setText("Store compressed");
		compressed_radio_choice.setActionCommand("Store uncompressed");
		getContentPane().add(compressed_radio_choice);
		compressed_radio_choice.setBounds(16,192,140,12);
		uncompressed_radio_choice.setText("Store Uncompressed");
		uncompressed_radio_choice.setActionCommand("Store Compressed");
		uncompressed_radio_choice.setSelected(true);
		getContentPane().add(uncompressed_radio_choice);
		uncompressed_radio_choice.setBounds(172,192,140,12);
		//$$ saved_logs_model.move(24,216);
		//$$ unzippedSaveModel.move(72,216);
		//$$ file_name_popup.move(48,216);
		//$$ JPopupMenu1.move(48,216);
		cutMenuItem.setText("Cut");
		cutMenuItem.setActionCommand("Cut");
		cutMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.Event.CTRL_MASK));
		file_name_popup.add(cutMenuItem);
		copyMenuItem.setText("Copy");
		copyMenuItem.setActionCommand("Copy");
		copyMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.Event.CTRL_MASK));
		file_name_popup.add(copyMenuItem);
		pasteMenuItem.setText("Paste");
		pasteMenuItem.setActionCommand("Paste");
		pasteMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.Event.CTRL_MASK));
		file_name_popup.add(pasteMenuItem);
		JButton1.setText("Cancel");
		JButton1.setActionCommand("Cancel");
		JButton1.setMnemonic((int)'C');
		getContentPane().add(JButton1);
		JButton1.setBounds(312,180,84,26);
		//$$ saved_logs_file.move(24,216);
		//$$ stringTableModel1.move(72,216);
		save_button.setIcon(saveIcon);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		compressed_radio_choice.addActionListener(lSymAction);
		uncompressed_radio_choice.addActionListener(lSymAction);
		save_button.addActionListener(lSymAction);
		cutMenuItem.addActionListener(lSymAction);
		copyMenuItem.addActionListener(lSymAction);
		pasteMenuItem.addActionListener(lSymAction);
		JButton1.addActionListener(lSymAction);
		//}}
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension panelSize = this.getSize();
        setLocation(screenSize.width/2 - (panelSize.width/2),
        screenSize.height/2 - (panelSize.height/2));
        
		this.file_name_field.addMouseListener(new MouseAdapter() {         
		    public void mouseClicked(MouseEvent me) {            
		        if (SwingUtilities.isRightMouseButton(me)) {              
		            file_name_popup.show(file_name_field, me.getX(), me.getY());  
		        }
		    }      
		 });
		this.setTableHeaders();
		this.fillSaveTableZippedEntries();
		this.fillSaveUnzippedEntriesTable();
		this.clipboard = this.getToolkit().getSystemClipboard();
	}

	public saveLogDialog() {
		this((Frame)null);
	}

	public saveLogDialog(String sTitle) {
		this();
		setTitle(sTitle);
	}
	
	private void setTableHeaders() {
	    this.saved_logs_model.setColumnHeaders("File, Last Edited");
	    this.unzippedSaveModel.setColumnHeaders("File, Last Edited");
	}
	
	public static boolean isZipped(String file_name) {
	    StringTokenizer parser = new StringTokenizer(file_name, ".");
	    boolean flag = false;
	    try {
	        if (parser != null) {
	            parser.nextToken();
	            if (parser.nextToken().equals("zip")) {
	                flag = true;
	                return flag;
	            }
	        }
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	    return flag;
	}
	
	private void fillSaveTableZippedEntries() {
	    File log = null;
	    try {
	        String[] logs = this.save_directory.list();
	        for (int i = 0; i < logs.length; i++) {
                log = new File(logs[i]);
                if ((isZipped(logs[i]))) {
	                this.saved_logs_model.addRow((log.getName() + ", " + new Date(log.lastModified()).toString()));
                    this.saved_logs_model.fireTableChanged(null);
	            }
	        }
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
	private void fillSaveUnzippedEntriesTable() {
	    File log = null;
	    try {
	        String[] logs = this.save_directory.list();
	        for (int i = 0; i < logs.length; i++) {
                log = new File(logs[i]);
                if (!(isZipped(logs[i]))) {
	                this.unzippedSaveModel.addRow((log.getName() + ", " + new Date(log.lastModified()).toString()));
                    this.unzippedSaveModel.fireTableChanged(null);
	            }
	        }
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}

    private void saveZipped() {
        StringBuffer log = new StringBuffer("");
        try {
            this.setVisible(false);
            for (int i = 0; i < this.log_text.size(); i++) {
                log.append((String) this.log_text.elementAt(i) + "\n");
            }
            FileOutputStream fos = new FileOutputStream(this.save_directory + File.separator + this.file_name_field.getText() + ".zip");    
            ZipOutputStream zos = new ZipOutputStream(fos);
            zos.setMethod(ZipOutputStream.DEFLATED);
            zos.putNextEntry(new ZipEntry(this.file_name_field.getText() + ".txt"));
            
            zos.write((log.toString().getBytes()), 0, (log.toString().getBytes()).length);
            zos.close();
            this.dispose(); 
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private void saveUnZipped() {
        StringBuffer log = new StringBuffer("");
        try {
            this.setVisible(false);
            for (int i = 0; i < this.log_text.size(); i++) {
                log.append((String) this.log_text.elementAt(i) + "\n");
            }
            PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(this.save_directory + File.separator + this.file_name_field.getText() + ".txt")));
            out.write(log.toString(), 0, (log.toString()).length());
            out.close();
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

	public void addNotify() {
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

    public void setID(String new_id) {
        this.id = new_id;
        this.file_name_field.setText(this.id);
    }

    public void setLogText(Vector log) {
        this.log_text = log;
    }

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JButton save_button = new javax.swing.JButton();
	javax.swing.JTextField file_name_field = new javax.swing.JTextField();
	com.symantec.itools.javax.swing.icons.ImageIcon saveIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTabbedPane JTabbedPane1 = new javax.swing.JTabbedPane();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JTable save_table = new javax.swing.JTable();
	javax.swing.JScrollPane JScrollPane2 = new javax.swing.JScrollPane();
	javax.swing.JTable unzipped_save_table = new javax.swing.JTable();
	javax.swing.JRadioButton compressed_radio_choice = new javax.swing.JRadioButton();
	javax.swing.JRadioButton uncompressed_radio_choice = new javax.swing.JRadioButton();
	com.symantec.itools.javax.swing.models.StringTableModel saved_logs_model = new com.symantec.itools.javax.swing.models.StringTableModel();
	com.symantec.itools.javax.swing.models.StringTableModel unzippedSaveModel = new com.symantec.itools.javax.swing.models.StringTableModel();
	javax.swing.JPopupMenu file_name_popup = new javax.swing.JPopupMenu();
	javax.swing.JMenuItem cutMenuItem = new javax.swing.JMenuItem();
	javax.swing.JMenuItem copyMenuItem = new javax.swing.JMenuItem();
	javax.swing.JMenuItem pasteMenuItem = new javax.swing.JMenuItem();
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	//}}
    Clipboard clipboard = null;
    String id = "";    
    String directory = ("logs" + File.separator);
    File save_directory = new File(System.getProperty("user.dir") + File.separator +  this.directory);
    Vector log_text = null;
    
    
	class SymAction implements java.awt.event.ActionListener {	    
		public void actionPerformed(java.awt.event.ActionEvent event) {
			Object object = event.getSource();
			if (object == compressed_radio_choice)
				compressed_radio_choice_actionPerformed(event);
			else if (object == uncompressed_radio_choice)
				uncompressed_radio_choice_actionPerformed(event);
			else if (object == save_button)
				saveButton_actionPerformed(event);
			else if (object == cutMenuItem)
				cutMenuItem_actionPerformed(event);
			else if (object == copyMenuItem)
				copyMenuItem_actionPerformed(event);
			else if (object == pasteMenuItem)
				pasteMenuItem_actionPerformed(event);
			else if (object == JButton1)
				JButton1_actionPerformed(event);
		}
	} /* end internal class SymAction() */

	void compressed_radio_choice_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		compressed_radio_choice_actionPerformed_Interaction1(event);
	}

	void compressed_radio_choice_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			uncompressed_radio_choice.setSelected(false);
		} catch (java.lang.Exception e) {
		    e.printStackTrace();
		}
	}

	void uncompressed_radio_choice_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		uncompressed_radio_choice_actionPerformed_Interaction1(event);
	}

	void uncompressed_radio_choice_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			compressed_radio_choice.setSelected(false);
		} catch (java.lang.Exception e) {
		    e.printStackTrace();
		}
	}

	void saveButton_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		save_button_actionPerformed_Interaction1(event);
	}

	void save_button_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
		    if (compressed_radio_choice.isSelected()) {
			    this.saveZipped();
			}else {
			    this.saveUnZipped();    
			}
		} catch (java.lang.Exception e) {
		    e.printStackTrace();
		}
	}

	void cutMenuItem_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		cutMenuItem_actionPerformed_Interaction1(event);
	}

	void cutMenuItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			file_name_field.cut();
		} catch (java.lang.Exception e) {
		    e.printStackTrace();
		}
	}

	void copyMenuItem_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		copyMenuItem_actionPerformed_Interaction1(event);
	}

	void copyMenuItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			file_name_field.copy();
		} catch (java.lang.Exception e) {
		    e.printStackTrace();
		}
	}

	void pasteMenuItem_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		pasteMenuItem_actionPerformed_Interaction1(event);
	}

	void pasteMenuItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			file_name_field.paste();
		} catch (java.lang.Exception e) {
		    e.printStackTrace();
		}
	}

	void JButton1_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		JButton1_actionPerformed_Interaction1(event);
	}

	void JButton1_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			this.dispose();
		} catch (java.lang.Exception e) {
		    e.printStackTrace();
		}
	}
}/* end class saveLogDialog() */