/****************************************************************************/
/* file - AddSystemTypeDialog.java                                          */
/* -------------------------------                                          */
/* This class implements the functionality for an administrator to add a new*/
/* system type to the database. This information, if customized is published*/
/* along with any customized questions to the client in XML format          */
/* -------------------------------                                          */
/* NIST Self-Assessment Tool                                                */
/* Author - Mark McLarnon                                                   */
/****************************************************************************/
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import com.symantec.itools.javax.swing.borders.BevelBorder;

public class AddSystemTypeDialog extends javax.swing.JDialog {
    
	public AddSystemTypeDialog(Frame parent) {
		super(parent);
		
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		getContentPane().setLayout(new BoxLayout(this.getContentPane(),BoxLayout.X_AXIS));
		setSize(347,126);
		setVisible(false);
		JPanel1.setBorder(bevelBorder1);
		JPanel1.setLayout(null);
		getContentPane().add(JPanel1);
		JButton1.setText("Ok");
		JButton1.setActionCommand("Ok");
		JPanel1.add(JButton1);
		JButton1.setBounds(95,88,80,25);
		JButton2.setText("Cancel");
		JButton2.setActionCommand("Cancel");
		JPanel1.add(JButton2);
		JButton2.setBounds(191,88,80,25);
		JLabel1.setText("Enter new system type:");
		JPanel1.add(JLabel1);
		JLabel1.setForeground(java.awt.Color.black);
		JLabel1.setBounds(12,12,251,34);
		JPanel1.add(systemTypeField);
		systemTypeField.setBounds(12,48,326,26);
		bevelBorder1.setBevelType(javax.swing.border.BevelBorder.LOWERED);
		//$$ bevelBorder1.move(0,199);
		//$$ typeFieldPopup.move(24,199);
		JMenuItem1.setText("Cut");
		JMenuItem1.setActionCommand("Cut");
		JMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.Event.CTRL_MASK));
		typeFieldPopup.add(JMenuItem1);
		JMenuItem2.setText("Copy");
		JMenuItem2.setActionCommand("Copy");
		JMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.Event.CTRL_MASK));
		typeFieldPopup.add(JMenuItem2);
		JMenuItem3.setText("Paste");
		JMenuItem3.setActionCommand("Paste");
		JMenuItem3.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.Event.CTRL_MASK));
		typeFieldPopup.add(JMenuItem3);
		//}}
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension panelSize = this.getSize();
        setLocation(screenSize.width/2 - (panelSize.width/2),
        screenSize.height/2 - (panelSize.height/2));
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		JButton2.addActionListener(lSymAction);
		JMenuItem1.addActionListener(lSymAction);
		JMenuItem2.addActionListener(lSymAction);
		JMenuItem3.addActionListener(lSymAction);
		//}}
		 systemTypeField.addMouseListener(new MouseAdapter() {         
		    public void mouseClicked(MouseEvent me) {            
		        if (SwingUtilities.isRightMouseButton(me)) {              
		            typeFieldPopup.show(systemTypeField, me.getX(), me.getY());
		        }
		    }      
		 });
	}

    public void setTypeValue(String val) {
        this.systemTypeField.setText(val);    
    }

	public AddSystemTypeDialog()
	{
		this((Frame)null);
	}

	public AddSystemTypeDialog(String sTitle) {
		this();
		setTitle(sTitle);
	}
	
	public AddSystemTypeDialog(QuestionFrame parent) {
		this();
		this.parent = parent;
	}

	public void addNotify() {
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	javax.swing.JButton JButton2 = new javax.swing.JButton();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField systemTypeField = new javax.swing.JTextField();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder1 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	javax.swing.JPopupMenu typeFieldPopup = new javax.swing.JPopupMenu();
	javax.swing.JMenuItem JMenuItem1 = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItem2 = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItem3 = new javax.swing.JMenuItem();
	//}}
    QuestionFrame parent = null;

	class SymAction implements java.awt.event.ActionListener {
	    
		public void actionPerformed(java.awt.event.ActionEvent event) {
			Object object = event.getSource();
			if (object == JButton2)
				JButton2_actionPerformed(event);
			else if (object == JMenuItem1)
				JMenuItem1_actionPerformed(event);
			else if (object == JMenuItem2)
				JMenuItem2_actionPerformed(event);
			else if (object == JMenuItem3)
				JMenuItem3_actionPerformed(event);
		}
	}/* end internal class SymAction() */

	void JButton2_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton2_actionPerformed_Interaction1(event);
	}

	void JButton2_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.dispose();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem1_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JMenuItem1_actionPerformed_Interaction1(event);
	}

	void JMenuItem1_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			systemTypeField.cut();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem2_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JMenuItem2_actionPerformed_Interaction1(event);
	}

	void JMenuItem2_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			systemTypeField.copy();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem3_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JMenuItem3_actionPerformed_Interaction1(event);
	}

	void JMenuItem3_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			systemTypeField.paste();
		} catch (java.lang.Exception e) {
		}
	}
}/* end class AddSystemTypeDialog() */