import java.awt.*;
import java.awt.event.*;
import java.sql.*;
import javax.swing.*;
import java.util.*;
import javax.swing.table.*;

public class AssessmentChooser extends javax.swing.JDialog {
    
	public AssessmentChooser(Frame parent) {
		super(parent);
		
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("Choose Assessment");
		setResizable(false);
		getContentPane().setLayout(null);
		setSize(567,234);
		setVisible(false);
		JButton1.setText("Continue");
		JButton1.setActionCommand("Continue");
		JButton1.setToolTipText("<html>Press this button to set the active assessment in the report window</html>");
		JButton1.setMnemonic((int)'C');
		getContentPane().add(JButton1);
		JButton1.setBounds(241,192,84,30);
		JLabel1.setText("Choose an assessment:");
		getContentPane().add(JLabel1);
		JLabel1.setForeground(java.awt.Color.black);
		JLabel1.setBounds(12,12,319,36);
		JScrollPane1.setOpaque(true);
		getContentPane().add(JScrollPane1);
		JScrollPane1.setBounds(12,48,540,138);
		assessment_chooser.setShowHorizontalLines(false);
		JScrollPane1.getViewport().add(assessment_chooser);
		assessment_chooser.setBounds(0,0,537,0);
		//}}

		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension panelSize = this.getSize();
        setLocation(screenSize.width/2 - (panelSize.width/2),
        screenSize.height/2 - (panelSize.height/2));
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		JButton1.addActionListener(lSymAction);
		SymKey aSymKey = new SymKey();
		JButton1.addKeyListener(aSymKey);
		//}}
		this.setAssessmentTableHeaders();
		this.assessment_chooser.setModel(this.assessments_model);
	}/* end default constructor AssessmentChooser() */
		
	public static AssessmentChooser spawnNewAssessmentChooser(ReportingFrame parent) {
	    return new AssessmentChooser(parent);   
	}
		
	private void setAssessmentTableHeaders() {
	    this.assessment_chooser_headers.addElement("System Name");
	    this.assessment_chooser_headers.addElement("System Number");
	    this.assessment_chooser_headers.addElement("Start Date");
	    this.assessment_chooser_headers.addElement("Assessment Identifier");
	    
	    this.assessments_model.setColumnIdentifiers(this.assessment_chooser_headers);
	}
	
	// Method that calls the database stored procedure get_saved_assessments. Its purpose is
	// to return the system name, start date and assessment identifier for all of the assessments
	// that a user will have stored in their assessment database.
	// ------------
	// Note the use of the .trim() calls to trim out whitespace for any string that is to be
	// added to the database, this removes the "..." that appears when a table column is to small
	// but all the text is still visible, what was extracted from the database was too big.
	public void populateAssessmentList() {
        CallableStatement query = null;
        ResultSet query_results = null;
        Connection conn = this.parent.parent.connectionGenerator();
        Vector table_row = new Vector();
	    try {
	        query = conn.prepareCall("{call get_saved_assessments}");
	        query_results = query.executeQuery();
	        String assessment_id = "";
	        while (query_results.next()) {
	            table_row = new Vector();
	            table_row.addElement((query_results.getString("component_name")).trim());
	            table_row.addElement((query_results.getString("component_num")).trim());
	            assessment_id = (query_results.getString("id")).trim();
	            table_row.addElement((query_results.getString("start_timestamp")).trim());
	            table_row.addElement(assessment_id);
	            this.assessments_model.addRow(table_row);
	        }
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}/* end method populateAssessmentList() */

	public AssessmentChooser() {
		this((Frame)null);
	}

	public AssessmentChooser(String sTitle) {
		this();
		setTitle(sTitle);
	}
	
	public AssessmentChooser(ReportingFrame parent) {
		this();
		this.parent = parent;        
		TableColumnModel model = assessment_chooser.getColumnModel();
        for (int i = 0; i < (this.assessment_chooser_headers).size(); i++) {
            (model.getColumn(i)).setHeaderRenderer(renderer);
        }                
        JTableHeader header = assessment_chooser.getTableHeader();
        header.addMouseListener(new HeaderListener(header,renderer));
        this.populateAssessmentList();
        this.assessment_chooser.setModel(this.assessments_model);

	}	

	public void addNotify() {
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JTable assessment_chooser = new javax.swing.JTable();
	//}}
	Vector assessment_chooser_headers = new Vector();
    ReportingFrame parent = null;
    SortableTableModel assessments_model = new SortableTableModel();
    SortButtonRenderer renderer = new SortButtonRenderer();
    
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == JButton1)
				JButton1_actionPerformed(event);
		}
	}
	
    class HeaderListener extends MouseAdapter {
        JTableHeader   header;    
        SortButtonRenderer renderer;      
    
        HeaderListener(JTableHeader header,SortButtonRenderer renderer) {      
            this.header   = header;      
            this.renderer = renderer;
        }
    
        public void mousePressed(MouseEvent e) {
            int col = header.columnAtPoint(e.getPoint());
            int sortCol = header.getTable().convertColumnIndexToModel(col);
            renderer.setPressedColumn(col);
            renderer.setSelectedColumn(col);
            header.repaint();
            if (header.getTable().isEditing()) {
                header.getTable().getCellEditor().stopCellEditing();
            }            
            boolean isAscent;      
            if (SortButtonRenderer.DOWN == renderer.getState(col)) {        
                isAscent = true;      
            }else {
                isAscent = false;
            }
            ((SortableTableModel)header.getTable().getModel()).sortByColumn(sortCol, isAscent);        
        } 
     
        public void mouseReleased(MouseEvent e) {      
    
            int col = header.columnAtPoint(e.getPoint());      
            renderer.setPressedColumn(-1);
                // clear      
            header.repaint();    
        }  
    }/* end internal class HeaderListener() */	

	void JButton1_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		JButton1_actionPerformed_Interaction1(event);
	}

	void JButton1_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			// AssessmentChooser Toggle show/hide
			this.proceedButtonActionHandler();
		} catch (java.lang.Exception e) {
		    e.printStackTrace();
		}
	}
	
	private void proceedButtonActionHandler() {
	    try {
			int selected_row = this.assessment_chooser.getSelectedRow();
			if (selected_row != -1) {
			    this.parent.setActiveName((String) ((Vector) (this.assessments_model.getDataVector()).elementAt(selected_row)).elementAt(0));
			    this.parent.setActiveNumber((String) ((Vector) (this.assessments_model.getDataVector()).elementAt(selected_row)).elementAt(1));
			    this.parent.setActiveDate((String) ((Vector) (this.assessments_model.getDataVector()).elementAt(selected_row)).elementAt(2));
			    this.parent.setActiveAssessment((String) ((Vector) (this.assessments_model.getDataVector()).elementAt(selected_row)).elementAt(3));
			    this.setVisible(!this.isVisible());
			}else {
			    this.parent.parent.displayErrorDialog("You must choose an assessment first!");    
			}	        
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
    private void continueButtonEnterPressed(java.awt.event.KeyEvent event) {
        try {
            if (event.getKeyChar() == KeyEvent.VK_ENTER) {
                this.proceedButtonActionHandler();
            }
        }catch (Exception e) {
            e.printStackTrace();
        }
    } 	
	

	class SymKey extends java.awt.event.KeyAdapter
	{
		public void keyTyped(java.awt.event.KeyEvent event)
		{
			Object object = event.getSource();
			if (object == JButton1)
				JButton1_keyTyped(event);
		}
	}

	void JButton1_keyTyped(java.awt.event.KeyEvent event)
	{
		// to do: code goes here.
			 
		JButton1_keyTyped_Interaction1(event);
	}

	void JButton1_keyTyped_Interaction1(java.awt.event.KeyEvent event)
	{
		try {
			this.continueButtonEnterPressed(event);
		} catch (java.lang.Exception e) {
		}
	}
}/* end class AssessmentChooser() */