/********************************************************************************/
/* file - AssessmentInfoDialog.java                                             */
/* --------------------------------                                             */
/* This class shows all of the relevant information about a system submitted to */
/* the administration database.                                                 */
/* --------------------------------                                             */
/* NIST Self-Assessment Tool                                                    */
/* Author - Mark McLarnon                                                       */
/********************************************************************************/
import java.awt.*;
import java.util.*;
import java.sql.*;
import javax.swing.*;

public class AssessmentInfoDialog extends javax.swing.JDialog {
    
	public AssessmentInfoDialog(Frame parent) {
		super(parent);
		
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("Assessment Information");
		setDefaultCloseOperation(javax.swing.JFrame.DISPOSE_ON_CLOSE);
		getContentPane().setLayout(null);
		setSize(435,400);
		setVisible(false);
		JButton1.setText("Ok");
		JButton1.setActionCommand("Ok");
		getContentPane().add(JButton1);
		JButton1.setBounds(185,366,65,26);
		getContentPane().add(system_name);
		system_name.setBounds(168,14,252,24);
		JLabel2.setText("System Assessed:");
		getContentPane().add(JLabel2);
		JLabel2.setForeground(java.awt.Color.black);
		JLabel2.setBounds(12,12,148,27);
		getContentPane().add(system_number);
		system_number.setBounds(168,48,253,25);
		JLabel3.setText("System Number:");
		getContentPane().add(JLabel3);
		JLabel3.setForeground(java.awt.Color.black);
		JLabel3.setBounds(12,48,147,27);
		getContentPane().add(system_type);
		system_type.setBounds(168,84,253,24);
		getContentPane().add(start_date);
		start_date.setBounds(168,120,253,24);
		getContentPane().add(completed);
		completed.setBounds(168,156,253,24);
		getContentPane().add(primary_assessor);
		primary_assessor.setBounds(168,192,253,24);
		JScrollPane1.setOpaque(true);
		getContentPane().add(JScrollPane1);
		JScrollPane1.setBounds(168,228,256,120);
		JScrollPane1.getViewport().add(assessment_objective);
		assessment_objective.setBounds(0,0,253,117);
		JLabel4.setText("System Type:");
		getContentPane().add(JLabel4);
		JLabel4.setForeground(java.awt.Color.black);
		JLabel4.setBounds(12,84,145,27);
		JLabel5.setText("Start Date:");
		getContentPane().add(JLabel5);
		JLabel5.setForeground(java.awt.Color.black);
		JLabel5.setBounds(12,120,147,25);
		JLabel6.setText("Completed:");
		getContentPane().add(JLabel6);
		JLabel6.setForeground(java.awt.Color.black);
		JLabel6.setBounds(12,156,147,28);
		JLabel7.setText("Primary Assessor:");
		getContentPane().add(JLabel7);
		JLabel7.setForeground(java.awt.Color.black);
		JLabel7.setBounds(12,192,144,24);
		JLabel8.setText("Objective:");
		getContentPane().add(JLabel8);
		JLabel8.setForeground(java.awt.Color.black);
		JLabel8.setBounds(12,228,150,32);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		JButton1.addActionListener(lSymAction);
		//}}
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension panelSize = this.getSize();
        setLocation(screenSize.width/2 - (panelSize.width/2),
        screenSize.height/2 - (panelSize.height/2));		
	}/* end default constructor AssessmentInfoDialog() */

	public AssessmentInfoDialog() {
		this((Frame)null);
	}

    public void setInformationFields() {
        CallableStatement dynamic_search = null;
        ResultSet search_results = null;
	    String component_name = "";
	    String component_num = "";
	    String component_location = "";
	    String component_type = "";
	    String component_assessment_obj = "";
	    String assessment_id = "";
	    String start_timestamp = "";
	    String completed = "";
        String bookmark = "";
	    String primary_assessor = "";
        Connection conn = this.parent.parent.connectionGenerator();                
        try {            
	        dynamic_search = conn.prepareCall("{call query_single_saved_assessment(?) }");
            dynamic_search.setString(1, this.getAssessmentID());
            search_results = dynamic_search.executeQuery();
            
            if (!search_results.next()) {
                this.setVisible(false);
                {
                    this.parent.parent.displayErrorDialog("No assessment matching that ID was found in the database!");
                }
                this.dispose();
            }else {            
	            component_name = (search_results.getString("component_name")).trim();
	            component_num = (search_results.getString("component_num")).trim();
	            component_location = (search_results.getString("component_location")).trim();
	            component_type = (search_results.getString("component_type")).trim();
	            component_assessment_obj = (search_results.getString("component_assessment_obj")).trim();
	            assessment_id = search_results.getString("assessment_id");
	            start_timestamp = search_results.getString("start_timestamp");
	            if (search_results.getInt("completed") == 1) {
	                completed = "Yes";
	            }else {
	                completed = "No"; 
	            }
	            bookmark = search_results.getString("bookmark");
	            primary_assessor = search_results.getString("primary_assessor");
	            this.system_name.setText(component_name);
	            this.system_number.setText(component_num);
	            System.out.println("assessment id is: " + this.getAssessmentID());
	            this.system_type.setText(component_type);
	            this.start_date.setText(start_timestamp);
	            this.completed.setText(completed);
	            this.primary_assessor.setText(primary_assessor);
	            this.assessment_objective.setText(component_assessment_obj);
            }
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

	public AssessmentInfoDialog(String sTitle) {
		this();
		setTitle(sTitle);
	}
	
    public AssessmentInfoDialog(AssessmentFrame parent, String assessment_id) {
		this();
		this.parent = parent;
		this.setAssessmentId(assessment_id);
		this.setInformationFields();
	}
	
	public static AssessmentInfoDialog showInfoDialog(String assessment_id, AssessmentFrame parent) {
	    return new AssessmentInfoDialog(parent, assessment_id);
	    
	}
	
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

    public void setAssessmentId(String new_id) {
        try {
            this.assessment_id = new_id;   
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String getAssessmentID() {
        return this.assessment_id;    
    }

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	javax.swing.JTextField system_name = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField system_number = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField system_type = new javax.swing.JTextField();
	javax.swing.JTextField start_date = new javax.swing.JTextField();
	javax.swing.JTextField completed = new javax.swing.JTextField();
	javax.swing.JTextField primary_assessor = new javax.swing.JTextField();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JTextPane assessment_objective = new javax.swing.JTextPane();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	//}}
    String assessment_id = "";
    AssessmentFrame parent = null;

	class SymAction implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent event) {
			Object object = event.getSource();
			if (object == JButton1)
				JButton1_actionPerformed(event);
		}
	}/* end class SymAction() */

	void JButton1_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		JButton1_actionPerformed_Interaction1(event);
	}

	void JButton1_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			this.dispose();
		} catch (java.lang.Exception e) {
		    e.printStackTrace();
		}
	}
}/* end class AssessmentInfoDialog() */