/********************************************************************************/
/* file DateChooser.java                                                        */
/* ---------------------                                                        */
/* This class allows a user to choose a date with which to search the assessmnet*/
/* database. It uses the IBM calendar bean from Alphaworks.                     */
/* ---------------------                                                        */
/* NIST Self-Assessment Tool.                                                   */
/* Author - Mark McLarnon                                                       */
/* ---------------------                                                        */
/* Change Control:                                                              */
/* 05/09/02 - Added code when dialog is closing to reset search window and to   */
/*            non-date search state (including the status bar of SATAdmin       */
/********************************************************************************/
import java.awt.*;
import javax.swing.*;
import com.ibm.calendar.Calendar;

public class DateChooser extends javax.swing.JDialog {
    
	public DateChooser(Frame parent) {
		super(parent);		
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("Choose Date");
		setResizable(false);
		setDefaultCloseOperation(javax.swing.JFrame.DISPOSE_ON_CLOSE);
		getContentPane().setLayout(null);
		setSize(176,192);
		setVisible(false);
		calendar1.setInitialDate(new java.util.Date(1018036083638L));
		getContentPane().add(calendar1);
		calendar1.setBounds(0,0,182,198);
		//}}
	
		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		calendar1.addMouseListener(aSymMouse);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		//}}
	}

	public DateChooser() {
		this((Frame)null);
	}

	public DateChooser(AssessmentFrame parent, String type) {
		this();
		this.parent = parent;
		if (type.equals("first")) {
		    this.first_date = true;    
		}else {
		    this.second_date = true;
		}
	}

	public DateChooser(String sTitle){
		this();
		setTitle(sTitle);
	}
	
	public void setDate() {
	    try {
	        this.setVisible(false);
	        if (first_date) {
	            this.parent.first_date.setText(calendar1.getSelectedDate().toString());  
	        }
	        this.dispose();
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}

	public void addNotify() {
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

    public void setFirstDate(boolean flag) {
        this.first_date = flag;
    }
    
    public void setSecondDate(boolean flag) {
        this.second_date = flag;
    }

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	com.ibm.calendar.Calendar calendar1 = new com.ibm.calendar.Calendar();
	//}}
    AssessmentFrame parent = null;
    boolean first_date = false;
    boolean second_date = false;

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == calendar1)
				calendar1_mouseClicked(event);
		}
	}

	void calendar1_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		calendar1_mouseClicked_Interaction1(event);
	}

	void calendar1_mouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
		try {
			this.setDate();
		} catch (java.lang.Exception e) {
		}
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == DateChooser.this)
				DateChooser_windowClosing(event);
		}
	}

	void DateChooser_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
		parent.parent.setStatusModeMsg("SEARCH");
		parent.parent.setStatusMsg("");
		parent.resetSearchPanel();
	}
}/* end class DateChooser() */