/********************************************************************************/
/* file EditQuestionDialog.java                                                 */
/* ----------------------------                                                 */
/* This class implements the functionality to edit/add a new question into the  */
/* current list of questions. The functionality is similar for both operations  */
/* which allows the same dialog to be used.                                     */
/* ----------------------------                                                 */
/* NIST Self-Assessment Tool                                                    */
/* Author - Mark McLarnon                                                       */
/********************************************************************************/
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import com.symantec.itools.javax.swing.borders.EmptyBorder;
import com.symantec.itools.javax.swing.borders.BevelBorder;

public class EditQuestionDialog extends javax.swing.JDialog {

	public EditQuestionDialog(Frame parent) {
		super(parent);
		
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		getContentPane().setLayout(new BoxLayout(this.getContentPane(),BoxLayout.X_AXIS));
		setSize(404,298);
		setVisible(false);
		emptyBorder1.setInsets(new java.awt.Insets(5,10,0,0));
		//$$ emptyBorder1.move(0,324);
		fields_border.setInsets(new java.awt.Insets(5,10,5,10));
		//$$ fields_border.move(24,324);
		//$$ majorSectionPopup.move(0,299);
		cutMenuItem.setText("Cut");
		cutMenuItem.setActionCommand("Cut");
		cutMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.Event.CTRL_MASK));
		majorSectionPopup.add(cutMenuItem);
		copyMenuItem.setText("Copy");
		copyMenuItem.setActionCommand("Copy");
		copyMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.Event.CTRL_MASK));
		majorSectionPopup.add(copyMenuItem);
		pasteMenuItem.setText("Paste");
		pasteMenuItem.setActionCommand("Paste");
		pasteMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.Event.CTRL_MASK));
		majorSectionPopup.add(pasteMenuItem);
		//$$ minorSectionPopup.move(24,299);
		minorCutMenuItem.setText("Cut");
		minorCutMenuItem.setActionCommand("Cut");
		minorCutMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.Event.CTRL_MASK));
		minorSectionPopup.add(minorCutMenuItem);
		minorCopyMenuItem.setText("Copy");
		minorCopyMenuItem.setActionCommand("Copy");
		minorCopyMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.Event.CTRL_MASK));
		minorSectionPopup.add(minorCopyMenuItem);
		minorPasteMenuItem.setText("Paste");
		minorPasteMenuItem.setActionCommand("Paste");
		minorPasteMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.Event.CTRL_MASK));
		minorSectionPopup.add(minorPasteMenuItem);
		//$$ numberPopup.move(48,299);
		JMenuItem4.setText("Cut");
		JMenuItem4.setActionCommand("Cut");
		JMenuItem4.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.Event.CTRL_MASK));
		numberPopup.add(JMenuItem4);
		JMenuItem5.setText("Copy");
		JMenuItem5.setActionCommand("Copy");
		JMenuItem5.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.Event.CTRL_MASK));
		numberPopup.add(JMenuItem5);
		JMenuItem6.setText("Paste");
		JMenuItem6.setActionCommand("Paste");
		JMenuItem6.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.Event.CTRL_MASK));
		numberPopup.add(JMenuItem6);
		//$$ textPopup.move(72,299);
		JMenuItem7.setText("Cut");
		JMenuItem7.setActionCommand("Cut");
		JMenuItem7.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.Event.CTRL_MASK));
		textPopup.add(JMenuItem7);
		JMenuItem8.setText("Copy");
		JMenuItem8.setActionCommand("Copy");
		JMenuItem8.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.Event.CTRL_MASK));
		textPopup.add(JMenuItem8);
		JMenuItem9.setText("Paste");
		JMenuItem9.setActionCommand("Paste");
		JMenuItem9.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.Event.CTRL_MASK));
		textPopup.add(JMenuItem9);
		//$$ controlAreaPopup.move(96,299);
		JMenuItem1.setText("Cut");
		JMenuItem1.setActionCommand("Cut");
		JMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.Event.CTRL_MASK));
		controlAreaPopup.add(JMenuItem1);
		JMenuItem2.setText("Copy");
		JMenuItem2.setActionCommand("Copy");
		JMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.Event.CTRL_MASK));
		controlAreaPopup.add(JMenuItem2);
		JMenuItem3.setText("Paste");
		JMenuItem3.setActionCommand("Paste");
		JMenuItem3.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.Event.CTRL_MASK));
		controlAreaPopup.add(JMenuItem3);
		JPanel1.setBorder(bevelBorder1);
		JPanel1.setLayout(null);
		getContentPane().add(JPanel1);
		JPanel2.setBorder(fields_border);
		JPanel2.setLayout(null);
		JPanel1.add(JPanel2);
		JPanel2.setBounds(0,0,404,264);
		JLabel2.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		JLabel2.setText("Major Section:");
		JPanel2.add(JLabel2);
		JLabel2.setForeground(java.awt.Color.black);
		JLabel2.setBounds(10,5,192,24);
		JPanel2.add(major_section);
		major_section.setBounds(202,5,192,24);
		JLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		JLabel3.setText("Minor Section:");
		JPanel2.add(JLabel3);
		JLabel3.setForeground(java.awt.Color.black);
		JLabel3.setBounds(10,43,192,24);
		JPanel2.add(minor_section);
		minor_section.setBounds(202,43,192,24);
		JLabel4.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		JLabel4.setText("Question Number:");
		JPanel2.add(JLabel4);
		JLabel4.setForeground(java.awt.Color.black);
		JLabel4.setBounds(10,81,192,24);
		JPanel2.add(number);
		number.setBounds(202,81,192,24);
		JLabel5.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		JLabel5.setText("Question Text:");
		JPanel2.add(JLabel5);
		JLabel5.setForeground(java.awt.Color.black);
		JLabel5.setBounds(10,155,98,24);
		JScrollPane1.setOpaque(true);
		JPanel2.add(JScrollPane1);
		JScrollPane1.setBounds(108,155,286,109);
		text.setLineWrap(true);
		text.setWrapStyleWord(true);
		JScrollPane1.getViewport().add(text);
		text.setBounds(0,0,283,106);
		JLabel1.setText("Control Area:");
		JPanel2.add(JLabel1);
		JLabel1.setForeground(java.awt.Color.black);
		JLabel1.setBounds(10,121,192,24);
		JPanel2.add(control_area);
		control_area.setBounds(202,121,192,24);
		JPanel3.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		JPanel1.add(JPanel3);
		JPanel3.setBounds(0,264,404,35);
		JButton1.setText("Continue");
		JButton1.setActionCommand("Continue");
		JButton1.setMnemonic((int)'C');
		JPanel3.add(JButton1);
		JButton2.setText("Cancel");
		JButton2.setActionCommand("Cancel");
		JButton2.setMnemonic((int)'A');
		JPanel3.add(JButton2);
		bevelBorder1.setBevelType(javax.swing.border.BevelBorder.LOWERED);
		//$$ bevelBorder1.move(120,299);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		JButton2.addActionListener(lSymAction);
		cutMenuItem.addActionListener(lSymAction);
		copyMenuItem.addActionListener(lSymAction);
		pasteMenuItem.addActionListener(lSymAction);
		minorCutMenuItem.addActionListener(lSymAction);
		minorCopyMenuItem.addActionListener(lSymAction);
		minorPasteMenuItem.addActionListener(lSymAction);
		JMenuItem4.addActionListener(lSymAction);
		JMenuItem5.addActionListener(lSymAction);
		JMenuItem6.addActionListener(lSymAction);
		JMenuItem7.addActionListener(lSymAction);
		JMenuItem8.addActionListener(lSymAction);
		JMenuItem9.addActionListener(lSymAction);
		JMenuItem1.addActionListener(lSymAction);
		JMenuItem2.addActionListener(lSymAction);
		JMenuItem3.addActionListener(lSymAction);
		SymMouse aSymMouse = new SymMouse();
		text.addMouseListener(aSymMouse);
		//}}
		major_section.addMouseListener(new MouseAdapter() {         
		    public void mouseClicked(MouseEvent me) {            
		        if (SwingUtilities.isRightMouseButton(me)) {              
		            majorSectionPopup.show(major_section, me.getX(), me.getY());
		        }
		    }      
		 });
		 minor_section.addMouseListener(new MouseAdapter() {         
		    public void mouseClicked(MouseEvent me) {            
		        if (SwingUtilities.isRightMouseButton(me)) {              
		            minorSectionPopup.show(minor_section, me.getX(), me.getY());
		        }
		    }      
		 }); 
		 number.addMouseListener(new MouseAdapter() {         
		    public void mouseClicked(MouseEvent me) {            
		        if (SwingUtilities.isRightMouseButton(me)) {              
		            numberPopup.show(number, me.getX(), me.getY());
		        }
		    }      
		 }); 
		 text.addMouseListener(new MouseAdapter() {         
		    public void mouseClicked(MouseEvent me) {            
		        if (SwingUtilities.isRightMouseButton(me)) {              
		            textPopup.show(text, me.getX(), me.getY());
		        }
		    }      
		 });
		 control_area.addMouseListener(new MouseAdapter() {         
		    public void mouseClicked(MouseEvent me) {            
		        if (SwingUtilities.isRightMouseButton(me)) {              
		            controlAreaPopup.show(control_area, me.getX(), me.getY());
		        }
		    }      
		 });
		
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension panelSize = this.getSize();
        setLocation(screenSize.width/2 - (panelSize.width/2),
        screenSize.height/2 - (panelSize.height/2));
	}

    public void displayQuestion(Vector question_data) {
        try {
            this.major_section.setText(((Integer) question_data.elementAt(0)).toString());
            this.minor_section.setText(((Integer) question_data.elementAt(1)).toString());
            this.number.setText(((Integer) question_data.elementAt(2)).toString());
            this.control_area.setText((String) question_data.elementAt(4));
            this.text.setText((String) question_data.elementAt(5));
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

	public EditQuestionDialog() {
		this((Frame)null);
	}

	public EditQuestionDialog(String sTitle) {
		this();
		setTitle(sTitle);
	}
	
	public EditQuestionDialog(QuestionFrame parent) {
		this();
		this.parent = parent;
	}
	
	public void addNotify() {
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

	// This method is designed to encapsulate changing the cursor type
	// it is used to show the user that an action is occurring that needs 
	// to pause for.
	private void internal_setCursor(String cursor_type) {
	    try {
	        if (cursor_type.equals("wait")) {
                this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.WAIT_CURSOR));
	        }else  if (cursor_type.equals("hand")) {
	            this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
	        }else  if (cursor_type.equals("text")) {
	            this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.TEXT_CURSOR));
	        }else  if (cursor_type.equals("default")) {
	            this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
	        }
	    }catch (Exception e) {
            ;
	    }
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	com.symantec.itools.javax.swing.borders.EmptyBorder emptyBorder1 = new com.symantec.itools.javax.swing.borders.EmptyBorder();
	com.symantec.itools.javax.swing.borders.EmptyBorder fields_border = new com.symantec.itools.javax.swing.borders.EmptyBorder();
	javax.swing.JPopupMenu majorSectionPopup = new javax.swing.JPopupMenu();
	javax.swing.JMenuItem cutMenuItem = new javax.swing.JMenuItem();
	javax.swing.JMenuItem copyMenuItem = new javax.swing.JMenuItem();
	javax.swing.JMenuItem pasteMenuItem = new javax.swing.JMenuItem();
	javax.swing.JPopupMenu minorSectionPopup = new javax.swing.JPopupMenu();
	javax.swing.JMenuItem minorCutMenuItem = new javax.swing.JMenuItem();
	javax.swing.JMenuItem minorCopyMenuItem = new javax.swing.JMenuItem();
	javax.swing.JMenuItem minorPasteMenuItem = new javax.swing.JMenuItem();
	javax.swing.JPopupMenu numberPopup = new javax.swing.JPopupMenu();
	javax.swing.JMenuItem JMenuItem4 = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItem5 = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItem6 = new javax.swing.JMenuItem();
	javax.swing.JPopupMenu textPopup = new javax.swing.JPopupMenu();
	javax.swing.JMenuItem JMenuItem7 = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItem8 = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItem9 = new javax.swing.JMenuItem();
	javax.swing.JPopupMenu controlAreaPopup = new javax.swing.JPopupMenu();
	javax.swing.JMenuItem JMenuItem1 = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItem2 = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItem3 = new javax.swing.JMenuItem();
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField major_section = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField minor_section = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField number = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JTextArea text = new javax.swing.JTextArea();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField control_area = new javax.swing.JTextField();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	javax.swing.JButton JButton2 = new javax.swing.JButton();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder1 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	//}}
    QuestionFrame parent = null;

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == JButton2)
				JButton2_actionPerformed(event);
			else if (object == cutMenuItem)
				cutMenuItem_actionPerformed(event);
			else if (object == copyMenuItem)
				copyMenuItem_actionPerformed(event);
			else if (object == pasteMenuItem)
				pasteMenuItem_actionPerformed(event);
			else if (object == minorCutMenuItem)
				minorCutMenuItem_actionPerformed(event);
			else if (object == minorCopyMenuItem)
				minorCopyMenuItem_actionPerformed(event);
			else if (object == minorPasteMenuItem)
				minorPasteMenuItem_actionPerformed(event);
			else if (object == JMenuItem4)
				JMenuItem4_actionPerformed(event);
			else if (object == JMenuItem5)
				JMenuItem5_actionPerformed(event);
			else if (object == JMenuItem6)
				JMenuItem6_actionPerformed(event);
			else if (object == JMenuItem7)
				JMenuItem7_actionPerformed(event);
			else if (object == JMenuItem8)
				JMenuItem8_actionPerformed(event);
			else if (object == JMenuItem9)
				JMenuItem9_actionPerformed(event);
			else if (object == JMenuItem1)
				JMenuItem1_actionPerformed(event);
			else if (object == JMenuItem2)
				JMenuItem2_actionPerformed(event);
			else if (object == JMenuItem3)
				JMenuItem3_actionPerformed(event);
		}
	}

	void JButton2_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton2_actionPerformed_Interaction1(event);
	}

	void JButton2_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.dispose();
		} catch (java.lang.Exception e) {
		}
	}

	void cutMenuItem_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		cutMenuItem_actionPerformed_Interaction1(event);
	}

	void cutMenuItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			minor_section.cut();
		} catch (java.lang.Exception e) {
		}
	}

	void copyMenuItem_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		copyMenuItem_actionPerformed_Interaction1(event);
	}

	void copyMenuItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			major_section.copy();
		} catch (java.lang.Exception e) {
		}
	}

	void pasteMenuItem_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		pasteMenuItem_actionPerformed_Interaction1(event);
	}

	void pasteMenuItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			major_section.paste();
		} catch (java.lang.Exception e) {
		}
	}

	void minorCutMenuItem_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		minorCutMenuItem_actionPerformed_Interaction1(event);
	}

	void minorCutMenuItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			minor_section.cut();
		} catch (java.lang.Exception e) {
		}
	}

	void minorCopyMenuItem_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		minorCopyMenuItem_actionPerformed_Interaction1(event);
	}

	void minorCopyMenuItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			minor_section.copy();
		} catch (java.lang.Exception e) {
		}
	}

	void minorPasteMenuItem_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		minorPasteMenuItem_actionPerformed_Interaction1(event);
	}

	void minorPasteMenuItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			minor_section.paste();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem4_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JMenuItem4_actionPerformed_Interaction1(event);
	}

	void JMenuItem4_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			number.cut();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem5_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JMenuItem5_actionPerformed_Interaction1(event);
	}

	void JMenuItem5_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			number.copy();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem6_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JMenuItem6_actionPerformed_Interaction1(event);
	}

	void JMenuItem6_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			number.paste();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem7_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JMenuItem7_actionPerformed_Interaction1(event);
	}

	void JMenuItem7_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			text.cut();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem8_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JMenuItem8_actionPerformed_Interaction1(event);
	}

	void JMenuItem8_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			text.copy();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem9_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		JMenuItem9_actionPerformed_Interaction1(event);
	}

	void JMenuItem9_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			text.paste();
		} catch (java.lang.Exception e) {
		
		}
	}

	void JMenuItem1_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		JMenuItem1_actionPerformed_Interaction1(event);
	}

	void JMenuItem1_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			control_area.cut();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem2_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		JMenuItem2_actionPerformed_Interaction1(event);
	}

	void JMenuItem2_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			control_area.copy();
		} catch (java.lang.Exception e) {
		}
	}

	void JMenuItem3_actionPerformed(java.awt.event.ActionEvent event) {
		// to do: code goes here.
			 
		JMenuItem3_actionPerformed_Interaction1(event);
	}

	void JMenuItem3_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			control_area.paste();
		} catch (java.lang.Exception e) {
		
		}
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseExited(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == text)
				text_mouseExited(event);
		}

		public void mouseEntered(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == text)
				text_mouseEntered(event);
		}
	}

	void text_mouseEntered(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		text_mouseEntered_Interaction1(event);
	}

	void text_mouseEntered_Interaction1(java.awt.event.MouseEvent event)
	{
		try {
			this.internal_setCursor("text");
		} catch (java.lang.Exception e) {
		}
	}

	void text_mouseExited(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		text_mouseExited_Interaction1(event);
	}

	void text_mouseExited_Interaction1(java.awt.event.MouseEvent event)
	{
		try {
			this.internal_setCursor("default");
		} catch (java.lang.Exception e) {
		}
	}
}/* end class EditQuestionDialog() */