/********************************************************************************/
/* file - QuestionFrame.java                                                    */
/* -------------------------                                                    */
/* This class implements the functionality to edit/interact with the question   */
/* list. It is used as a JInternalFrame within the SATAdmin class               */
/* -------------------------                                                    */
/* NIST Self-Assessment Tool                                                    */
/* Author - Mark McLarnon                                                       */
/* -------------------------                                                    */
/* References:                                                                  */
/* http://www.esus.com/javaindex/j2se/jdk1.2/javaxswing/editableatomiccontrols/ */
/* jtable/jtabledetectsel.html                                                  */
/* http://www.esus.com/javaindex/j2se/jdk1.2/javaxswing/editableatomiccontrols/ */
/* jtable/jtablewidthcolumn.html                                                */
/********************************************************************************/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.sql.*;
import java.io.*;
import org.jdom.Element;
import org.jdom.DocType;
import org.jdom.Document;
import org.jdom.output.*;
import org.xml.sax.*;
import org.apache.xerces.parsers.*;
import org.w3c.dom.*;
import org.w3c.dom.traversal.*;  
import com.symantec.itools.javax.swing.models.StringTableModel;
import com.symantec.itools.javax.swing.icons.ImageIcon;
import com.symantec.itools.javax.swing.JToolBarSeparator;

public class QuestionFrame extends javax.swing.JInternalFrame implements Serializable {
    
	public QuestionFrame() {
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		getContentPane().setLayout(new BorderLayout(0,0));
		setSize(573,305);
		JPanel2.setAlignmentY(0.454545F);
		JPanel2.setLayout(new BoxLayout(JPanel2,BoxLayout.X_AXIS));
		getContentPane().add(BorderLayout.NORTH, JPanel2);
		JToolBar1.setAlignmentY(0.482759F);
		JPanel2.add(JToolBar1);
		JButton1.setActionCommand("jbutton");
		JButton1.setDefaultCapable(false);
		JButton1.setToolTipText("Edit currently selected entry");
		JButton1.setMnemonic((int)'E');
		JToolBar1.add(JButton1);
		JButton4.setActionCommand("Delete Question");
		JButton4.setDefaultCapable(false);
		JButton4.setToolTipText("Delete currently selected entry");
		JButton4.setMnemonic((int)'D');
		JToolBar1.add(JButton4);
		JButton2.setActionCommand("Save Questions");
		JButton2.setDefaultCapable(false);
		JButton2.setToolTipText("Save checklist data");
		JButton2.setMnemonic((int)'S');
		JToolBar1.add(JButton2);
		JButton5.setDefaultCapable(false);
		JButton5.setToolTipText("Export checklist data to XML");
		JButton5.setMnemonic((int)'X');
		JToolBar1.add(JButton5);
		JButton6.setDefaultCapable(false);
		JButton6.setToolTipText("Print Results");
		JButton6.setMnemonic((int)'P');
		JToolBar1.add(JButton6);
		JButton3.setActionCommand("Export Questions");
		JButton3.setDefaultCapable(false);
		JButton3.setToolTipText("Add new entry");
		JButton3.setMnemonic((int)'A');
		JToolBar1.add(JButton3);
		JPanel1.setLayout(new BorderLayout(0,0));
		getContentPane().add(BorderLayout.CENTER, JPanel1);
		JPanel1.add(BorderLayout.CENTER, JTabbedPane1);
		JPanel3.setLayout(new BoxLayout(JPanel3,BoxLayout.X_AXIS));
		JTabbedPane1.add(JPanel3);
		JPanel3.setBounds(2,24,568,245);
		JPanel3.setVisible(false);
		JScrollPane1.setOpaque(true);
		JPanel3.add(JScrollPane1);
		questionTable.setRowHeight(60);
		JScrollPane1.getViewport().add(questionTable);
		questionTable.setBounds(0,0,565,0);
		JPanel4.setLayout(new BoxLayout(JPanel4,BoxLayout.X_AXIS));
		JTabbedPane1.add(JPanel4);
		JPanel4.setBounds(2,24,568,245);
		JPanel4.setVisible(false);
		JScrollPane2.setOpaque(true);
		JPanel4.add(JScrollPane2);
		systemTypeTable.setToolTipText("Shows the curently available system types for an assessor to choose from");
		JScrollPane2.getViewport().add(systemTypeTable);
		systemTypeTable.setBounds(0,0,565,0);
		JTabbedPane1.setSelectedIndex(0);
		JTabbedPane1.setSelectedComponent(JPanel3);
		JTabbedPane1.setTitleAt(0,"Questions");
		JTabbedPane1.setTitleAt(1,"System Types");
		try {
			deleteIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/delete.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ deleteIcon.move(0,306);
		try {
			saveIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/save.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ saveIcon.move(24,306);
		try {
			editIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/props.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ editIcon.move(48,306);
		try {
			imageIcon1.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/default.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ imageIcon1.move(72,306);
		try {
			printIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/print.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ printIcon.move(96,306);
		try {
			imageIcon2.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/new.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ imageIcon2.move(120,306);
		JButton1.setIcon(editIcon);
		JButton3.setIcon(imageIcon1);
		JButton4.setIcon(deleteIcon);
		JButton2.setIcon(saveIcon);
		JButton5.setIcon(imageIcon2);
		JButton6.setIcon(printIcon);
		//}}
		
		this.questionTable.addMouseListener(new MouseAdapter() {         
		    public void mouseClicked(MouseEvent me) {            
                if (me.getClickCount() == 2) {
                    int row = questionTable.rowAtPoint(me.getPoint());
                    openEditDialog((Vector) (question_table_model.getDataVector()).elementAt(row));
                }
		    }      
		 }); 

		this.prgMonitor = new ProgressDialog();
		
		this.computeQuestionCount();
		this.prgMonitor.setProgressMax(this.question_count);
		
		this.setQuestionTableColumnHeaders();
        this.setSysTypeTableColumnHeaders();
        
		this.fillTable();
		this.fillSystemTypeTable();
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		JButton1.addActionListener(lSymAction);
		SymInternalFrame lSymInternalFrame = new SymInternalFrame();
		this.addInternalFrameListener(lSymInternalFrame);
		JButton4.addActionListener(lSymAction);
		JButton5.addActionListener(lSymAction);
		JButton3.addActionListener(lSymAction);
		//}}
		this.xml_exporter.setDialogTitle("Export Checklist Data To XML");
		this.xml_exporter.addChoosableFileFilter(new XMLFilter());
	}/* end default constructor QuestionFrame() */
	 
	private String padWithNewLines(String unpadded_string, int spaces) {
	    StringBuffer buffer = new StringBuffer("");
        StringTokenizer parser = new StringTokenizer(unpadded_string, " ");
	    int token_count = 0;
	    int remainder = 0;
	    try {
	        token_count = parser.countTokens();
	        remainder = token_count % spaces;
            for (int i = 0; i < (token_count/spaces); i++) {
                for (int j = 0; j < spaces; j++) {
                    buffer.append(parser.nextToken() + " ");
                }
                buffer.append("\n");
            }
            for (int k = 0; k < remainder; k++) {
                buffer.append(parser.nextToken() + " ");
            }
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	    return buffer.toString();
	}
	
	public void showXMLSaveDialog() {
	    File save_target = null;
	    try {
	        int ret_val = this.xml_exporter.showSaveDialog(this);
	        if (ret_val == this.xml_exporter.APPROVE_OPTION) {
	            save_target = this.xml_exporter.getSelectedFile();
	            this.exportChecklistData(save_target.getName());
	        }
	        
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
	public void editButtonPushed() {
	    try {
	        if (this.JTabbedPane1.getSelectedIndex() == 0) {
	            int row = questionTable.getSelectedRow();
	            this.openEditDialog((Vector)(this.question_table_model.getDataVector()).elementAt(row));
	        }else {
	            int row = this.systemTypeTable.getSelectedRow();
	            System.out.println("edit system type button pushed");
	            AddSystemTypeDialog addsystd = new AddSystemTypeDialog();
	            addsystd.setTypeValue((String)((Vector)(this.systype_table_model.getDataVector()).elementAt(row)).elementAt(0));
	            addsystd.setVisible(true);
	        }
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
    public void deleteButtonPushed() {
	    Vector row_data = null;
	    try {
	        if (this.JTabbedPane1.getSelectedIndex() == 0) {
	            int row = questionTable.getSelectedRow();
	            row_data = (Vector) (question_table_model.getDataVector()).elementAt(row);
	            int version = ((Integer) row_data.elementAt(3)).intValue();
	            if (version != 0) {
                    this.question_table_model.removeRow(row);
                }else {
                    this.displayErrorDialog("You cannot delete a baseline question from the checklist!");
                }
            }else {
                System.out.println("delete system type button pushed");
            }
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
	public void exportChecklistData(String file_name) {
	    Vector temp_row = null;
	    Element question = null;
	    Element maj = null;
	    Element min = null;
	    Element ques_num = null;
	    Element ver = null;
	    Element cntrl_obj = null;
	    Element text = null;
	    
	    Element sys_type = null;
	    try {
	        this.prgMonitor.clear();
	        this.prgMonitor.setProgressMax((this.question_table_model.getDataVector()).size());
	        this.prgMonitor.setStatusBusyMessage("Exporting checklist data to XML now, please hold");
	        this.checklist_xml_root = new Element("checklist");
	        this.checklist_final_export = new Document(this.checklist_xml_root);
            this.xml_question_root = new Element("questions"); 
            this.xml_systype_root = new Element("systemtypes");
	        this.checklist_xml_root.addContent(this.xml_question_root);
	        for (int i = 0; i < (this.question_table_model.getDataVector()).size(); i++) {
                temp_row = (Vector) (this.question_table_model.getDataVector()).elementAt(i);
                question = new Element("question");
                maj = new Element("majornumber");
                maj.addContent(((Integer) temp_row.elementAt(0)).toString());
                question.addContent(maj);
                min = new Element("minnumber");
                min.addContent(((Integer) temp_row.elementAt(1)).toString());
                question.addContent(min);
                ques_num = new Element("quesnumber");
                ques_num.addContent(((Integer) temp_row.elementAt(2)).toString());
                question.addContent(ques_num);
                ver = new Element("version");
                ver.addContent(((Integer) temp_row.elementAt(3)).toString());
                question.addContent(ver);
                cntrl_obj = new Element("controlobjective");
                cntrl_obj.addContent((String) temp_row.elementAt(4));
                question.addContent(cntrl_obj);
                text = new Element("questiontext");
                text.addContent((String) temp_row.elementAt(5));
                question.addContent(text);
                this.xml_question_root.addContent(question);
                this.prgMonitor.setNormalizedProgress(i);
	        }
	        this.prgMonitor.setStatusBusyMessage("Now exporting system types, please hold");
	        this.checklist_xml_root.addContent(this.xml_systype_root);
	        for (int n = 0; n < (systype_table_model.getDataVector()).size(); n++) {
	            temp_row = (Vector) (this.systype_table_model.getDataVector()).elementAt(n);
	            sys_type = new Element("systemtype");
	            sys_type.addContent((String)temp_row.elementAt(0));
	            this.xml_systype_root.addContent(sys_type);
	        }
	        XMLOutputter fmt = new XMLOutputter();
	        PrintWriter output_stream = new PrintWriter(new FileWriter(file_name));
	        fmt.output(this.checklist_final_export, output_stream);
	        this.prgMonitor.setStatusBusyMessage("Finished!");
	        this.prgMonitor.setVisible(false);
	        this.displayStatusDialog("Checklist export complete!");
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
    private void displayErrorDialog(String msg) {
        try {
            JOptionPane.showMessageDialog(this, msg, "Error:", JOptionPane.ERROR_MESSAGE);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
	
	private void displayStatusDialog(String msg) {
        try {
            JOptionPane.showMessageDialog(this, msg, "System Message:", JOptionPane.INFORMATION_MESSAGE);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
	
	public void openEditDialog(Vector row_Data) {
        try {
            EditQuestionDialog diag = new EditQuestionDialog(this);
            diag.displayQuestion(row_Data);
            diag.setVisible(true);
        }catch (Exception e) {
            e.printStackTrace();
        }          
	}
	
    public void openAddDialog() {
        try {
            EditQuestionDialog diag = new EditQuestionDialog();
            diag.setVisible(true);
        }catch (Exception e) {
            e.printStackTrace();
        }          
	}
	
	public void computeQuestionCount() {
        CallableStatement current_count = null;
	    ResultSet count = null;
	    Vector table_row = new Vector();
        Connection conn = this.connectionGenerator();
	    try {
	       System.out.println("computing original question count now...");
	       conn = this.connectionGenerator();
           this.internal_setCursor("wait"); 
            
           current_count =  conn.prepareCall("{call get_question_count}");
           count = current_count.executeQuery();
           count.next();
           this.question_count = count.getInt("QuestionCount");
           conn.close(); 
	       this.internal_setCursor("default");
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	      
	}
	
	public void setSysTypeTableColumnHeaders() {
	    Vector headers = new Vector();
	    try {
	        headers.addElement("System Type");	        
	        this.systype_table_model.setColumnIdentifiers(headers);
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
    public void setQuestionTableColumnHeaders() {
	    Vector headers = new Vector();
	    try {
	        headers.addElement("Major Section");
	        headers.addElement("Minor Section");
	        headers.addElement("Number");
	        headers.addElement("Version");
	        headers.addElement("Control Area");
	        headers.addElement("Text");
	        
	        this.question_table_model.setColumnIdentifiers(headers);
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}

	public QuestionFrame(String sTitle) {
		this();
		setTitle(sTitle);
	}
	
	public QuestionFrame(SATAdmin parent_frame) {
		this();
		
		this.parent = parent_frame;
	}
    
    private Connection connectionGenerator() {
        try {
            return DriverManager.getConnection(this.parent.props.getProperty("sat.data.connstring"), this.parent.props.getProperty("sat.data.username"), this.parent.props.getProperty("sat.data.password"));
        }catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }    
    
    // This method is designed to encapsulate changing the cursor type
	// it is used to show the user that an action is occurring that needs 
	// to pause for.
	private void internal_setCursor(String cursor_type) {
	    try {
	        if (cursor_type.equals("wait")) {
                this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.WAIT_CURSOR));
	        }else  if (cursor_type.equals("default")) {
	            this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
	        }
	    }catch (Exception e) {
            ;
	    }
	}
	private void fillSystemTypeTable() {
        CallableStatement current_systypes = null;
	    ResultSet types = null;
	    Vector table_row = new Vector();
        Connection conn = this.connectionGenerator();
        int progress = 0;
	    try {
	           this.internal_setCursor("wait");
	           current_systypes =  conn.prepareCall("{call get_sys_types}");
	           types = current_systypes.executeQuery();	       
	           while (types.next()) {
	               table_row = new Vector();
	               table_row.addElement(types.getString("component_type"));
	               this.systype_table_model.addRow(table_row);	               
	           }
	           this.systemTypeTable.setModel(this.systype_table_model);
        
	       conn.close();
	       this.internal_setCursor("default");
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	    
	}
	
	private void fillTable() {
        CallableStatement current_questions = null;
	    ResultSet questions = null;
	    Vector table_row = new Vector();
        Connection conn = this.connectionGenerator();
        int progress = 0;
	    try {
	       File test_cache_exists = new File(question_map_cache);
	       if (!test_cache_exists.exists()) {
	           this.internal_setCursor("wait");
	           this.prgMonitor.setStatusBusyMessage("Please hold, caching question list to improve execution, this only needs to be done each time the question list is updated and saved");
	           this.prgMonitor.setVisible(true);
	           current_questions =  conn.prepareCall("{call get_questions(?)}");
               current_questions.setInt(1, 0);
	           questions = current_questions.executeQuery();	       
	           String cntrl_area = "";
	           while (questions.next()) {
	               table_row = new Vector();
	               cntrl_area = questions.getString("area_name");
	               table_row.addElement(new Integer(questions.getInt("major_section")));
	               table_row.addElement(new Integer(questions.getInt("minor_section")));
	               table_row.addElement(new Integer(questions.getInt("question_number")));	               
	               table_row.addElement(new Integer(questions.getInt("version")));
	               table_row.addElement(cntrl_area);
	               table_row.addElement(questions.getString("question_text"));
	               this.question_table_model.addRow(table_row);
	               
	               progress++;
	               this.prgMonitor.setNormalizedProgress(progress);
	           }
	           this.prgMonitor.setVisible(false);
	           this.prgMonitor.dispose();
	           this.questionTable.setModel(this.question_table_model);

               this.questionTable.getColumn("Text").setCellRenderer(new TextAreaRenderer());
               this.questionTable.getColumn("Text").setCellEditor(new TextAreaEditor());
		
		       TableColumn column = this.questionTable.getColumn("Text");
		       column.setWidth(190);
               column.setPreferredWidth(170);

		       TableColumn column2 = this.questionTable.getColumn("Control Area");
		       column2.setWidth(100);
               column2.setPreferredWidth(100);
        
	           FileOutputStream fos = new FileOutputStream(question_map_cache);
	           ObjectOutputStream oos = new ObjectOutputStream(fos);
	           oos.writeObject(question_table_model);
	       }else {
	           FileInputStream fis = new FileInputStream(question_map_cache); 
	           ObjectInputStream ois = new ObjectInputStream(fis);
	           
	           question_table_model = (DefaultTableModel) ois.readObject();	           
	           this.questionTable.setModel(this.question_table_model);
	           
               this.questionTable.getColumn("Text").setCellRenderer(new TextAreaRenderer());
               this.questionTable.getColumn("Text").setCellEditor(new TextAreaEditor());
	           
               TableColumn column = this.questionTable.getColumn("Text");
		       column.setWidth(190);
               column.setPreferredWidth(170);

		       TableColumn column2 = this.questionTable.getColumn("Control Area");
		       column2.setWidth(100);
               column2.setPreferredWidth(100);               
               
	           ois.close();
	       }
	       conn.close();
	       this.internal_setCursor("default");
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	    
	}

    public void addNewItem() {
        try {
             if (this.JTabbedPane1.getSelectedIndex() == 0) {
                EditQuestionDialog diag = new EditQuestionDialog(this);
                diag.setVisible(true);
             }
             if (this.JTabbedPane1.getSelectedIndex() == 1) {
                AddSystemTypeDialog type = new AddSystemTypeDialog(this);
                type.setVisible(true);
             }
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

	public void addNotify() {
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets and menu bar
		Insets insets = getInsets();
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
			menuBarHeight = menuBar.getPreferredSize().height;
		int offset = 0;
		Component comp[] = getComponents();
		for(int i = 0; i < comp.length; ++i) {
			if (comp[i] instanceof javax.swing.JRootPane)
				continue;
			offset += comp[i].getPreferredSize().height;
		}
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight + offset);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JToolBar JToolBar1 = new javax.swing.JToolBar();
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	javax.swing.JButton JButton4 = new javax.swing.JButton();
	javax.swing.JButton JButton2 = new javax.swing.JButton();
	javax.swing.JButton JButton5 = new javax.swing.JButton();
	javax.swing.JButton JButton6 = new javax.swing.JButton();
	javax.swing.JButton JButton3 = new javax.swing.JButton();
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JTabbedPane JTabbedPane1 = new javax.swing.JTabbedPane();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JTable questionTable = new javax.swing.JTable();
	javax.swing.JPanel JPanel4 = new javax.swing.JPanel();
	javax.swing.JScrollPane JScrollPane2 = new javax.swing.JScrollPane();
	javax.swing.JTable systemTypeTable = new javax.swing.JTable();
	com.symantec.itools.javax.swing.icons.ImageIcon deleteIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon saveIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon editIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon imageIcon1 = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon printIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon imageIcon2 = new com.symantec.itools.javax.swing.icons.ImageIcon();
	//}}
	DefaultTableModel question_table_model = new DefaultTableModel();
	DefaultTableModel systype_table_model = new DefaultTableModel();
    SATAdmin parent = null;
    String question_map_cache = "questions.dat";
    ProgressDialog prgMonitor = null;
    
    Element checklist_xml_root = null;
    Element xml_question_root = null;
    Element xml_systype_root = null;
    Document checklist_final_export = null;
    
    JFileChooser xml_exporter = new JFileChooser();
    int question_count = 0;
    
	public void finalize() throws Throwable
	{
		//{{CLEANUP
		//}}
		
		super.finalize();
	}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == JButton1)
				JButton1_actionPerformed(event);
			else if (object == JButton4)
				JButton4_actionPerformed(event);
			else if (object == JButton5)
				JButton5_actionPerformed(event);
			else if (object == JButton3)
				JButton3_actionPerformed(event);
		}
	}

	void JButton1_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton1_actionPerformed_Interaction1(event);
	}

	void JButton1_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.editButtonPushed();
		} catch (java.lang.Exception e) {
		}
	}

	class SymInternalFrame implements javax.swing.event.InternalFrameListener
	{
		public void internalFrameOpened(javax.swing.event.InternalFrameEvent event)
		{
		}

		public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent event)
		{
		    parent.setStatusModeMsg("QUES");    
		}

		public void internalFrameIconified(javax.swing.event.InternalFrameEvent event)
		{
		    parent.setStatusModeMsg("     ");
		}

		public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent event)
		{
		}

		public void internalFrameClosed(javax.swing.event.InternalFrameEvent event)
		{
		}

		public void internalFrameClosing(javax.swing.event.InternalFrameEvent event)
		{
			Object object = event.getSource();
			if (object == QuestionFrame.this)
				QuestionFrame_internalFrameClosing(event);
		}

		public void internalFrameActivated(javax.swing.event.InternalFrameEvent event)
		{
		}
	}/* end inner class SymInternalFrame() */

	void QuestionFrame_internalFrameClosing(javax.swing.event.InternalFrameEvent event)
	{
		// to do: code goes here.
		this.parent.qFrameopened = false;
		this.setVisible(false);
	}

	void JButton4_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton4_actionPerformed_Interaction1(event);
	}

	void JButton4_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.deleteButtonPushed();
		} catch (java.lang.Exception e) {
		}
	}

	void JButton5_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton5_actionPerformed_Interaction1(event);
	}

	void JButton5_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.showXMLSaveDialog();
		} catch (java.lang.Exception e) {
		}
	}

	void JButton3_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton3_actionPerformed_Interaction1(event);
	}

	void JButton3_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.editButtonPushed();
		} catch (java.lang.Exception e) {
		}
	}
}/* end class QuestionFrame() */