/********************************************************************************/
/* file - SATAdmin.java                                                         */
/* --------------------                                                         */
/* This class implements the user inteface for the Self-Assessment admin tool   */
/* It models itself after the MMC program from Microsoft for administration of  */
/* of Windows systems and programs.                                             */
/* --------------------                                                         */
/* NIST Self-Assessment Tool                                                    */
/* Author - Mark McLarnon                                                       */
/* --------------------                                                         */
/* TO COMPILE THIS CLASS/PROJECT:                                               */
/* If you wish to recompile this class, be aware that it uses several classes   */
/* that are not in the standard source distribution. First of all you must make */
/* sure that the following libraries are accessible within the system classpath */
/* on your development machine:                                                 */
/* 1. jdom.jar (From the JDom Project)                                          */
/* 2. xercesImpl.jar (The Xerces XML parser from Apache)                        */
/* 3. xmlParserAPIs.jar (Also from Apache)                                      */
/* 4. asset.jar (THE EVER IMPORTANT CLIENT JAR that contains the code for to    */
/*               create a new assessment and open current ones...)              */
/* 5. asset_core.jar This archive contains the core files used by both System   */
/*    and Manager. (used to be called logger.jar)                               */
/* 6. calendar.jar This file contains the Java beans that implement the calendar*/
/*                 for searching by date.                                       */
/* --------------------                                                         */
/* References:                                                                  */
/* http://dbserv.jinr.ru/js/content/java/New-tutorial/ui/swing/filechooser.html */
/* http://java.sun.com/docs/books/tutorial/uiswing/misc/plaf.html               */
/* http://support.microsoft.com/default.aspx?scid=kb;EN-US;q241397              */
/********************************************************************************/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.sql.*;
import symantec.itools.lang.Context;
import com.symantec.itools.beans.PropertyChangeSupport;
import com.symantec.itools.beans.VetoableChangeSupport;
import com.symantec.itools.javax.swing.JToolBarSeparator;
import com.symantec.itools.javax.swing.icons.ImageIcon;
import com.symantec.itools.javax.swing.borders.BevelBorder;
import com.symantec.itools.javax.swing.borders.EtchedBorder;
import com.symantec.itools.javax.swing.JSplitPaneWrapper;
import com.symantec.itools.javax.swing.JWrappingLabel;
import com.symantec.itools.javax.swing.borders.EmptyBorder;
import org.xml.sax.*;

public class SATAdmin extends javax.swing.JFrame implements ASSET {
    
    // The default constructor for the SATAdmin class. Note how the props class variable 
    // is initialized. It makes a static call to a factory method in order create an 
    // instance of the ASSETManagerPropertyManager class but specifies a file name of the
    // properties file.
	public SATAdmin() {
	    props = ASSETManagerPropertyManager.initializePropertyManager(this, "admin.conf");		
	    try {
		    Class.forName(this.props.getProperty("sat.data.driver"));
		}catch (Exception e) {
		    e.printStackTrace();    
		}
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("NIST ASSET Manager");
		setDefaultCloseOperation(javax.swing.JFrame.DISPOSE_ON_CLOSE);
		getContentPane().setLayout(new BorderLayout(0,0));
		setSize(753,574);
		setVisible(false);
		try {
			newIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/new.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ newIcon.move(144,312);
		try {
			openIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/open.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ openIcon.move(120,312);
		try {
			saveIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/save.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ saveIcon.move(96,312);
		try {
			cutIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/cut.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ cutIcon.move(72,312);
		try {
			copyIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/copy.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ copyIcon.move(48,312);
		try {
			pasteIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/paste.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ pasteIcon.move(24,312);
		try {
			aboutIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/about.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ aboutIcon.move(0,312);
		JPanel2.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		getContentPane().add(BorderLayout.NORTH, JPanel2);
		JPanel1.setAlignmentY(0.0F);
		JPanel1.setBorder(etchedBorder1);
		JPanel1.setLayout(new BoxLayout(JPanel1,BoxLayout.X_AXIS));
		getContentPane().add(BorderLayout.CENTER, JPanel1);
		JPanel1.add(JSplitPaneWrapper1);
		JScrollPane1.setOpaque(true);
		JSplitPaneWrapper1.add(JScrollPane1);
		JScrollPane1.setBounds(1,1,81,549);
		menuTree.setToolTipText("<html>Self-Assessment Tool Admistration options</html>");
		menuTree.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.CROSSHAIR_CURSOR));
		JScrollPane1.getViewport().add(menuTree);
		menuTree.setBounds(0,0,78,546);
		right_panel.setLayout(new BorderLayout(0,0));
		JSplitPaneWrapper1.add(right_panel);
		right_panel.setBackground(new java.awt.Color(204,204,204));
		right_panel.setBounds(92,1,656,549);
		bevelBorder1.setBevelType(javax.swing.border.BevelBorder.LOWERED);
		//$$ bevelBorder1.move(192,312);
		//$$ etchedBorder1.move(216,312);
		emptyBorder1.setInsets(new java.awt.Insets(20,20,0,0));
		//$$ emptyBorder1.move(0,575);
		try {
			importIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/open.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ importIcon.move(24,575);
		try {
			searchIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/find16.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ searchIcon.move(48,575);
		try {
			questionIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/default.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ questionIcon.move(72,575);
		//$$ imageIcon4.move(96,575);
		JPanel3.setLayout(new BorderLayout(0,0));
		getContentPane().add(BorderLayout.SOUTH, JPanel3);
		JPanel4.setAlignmentY(0.466667F);
		JPanel4.setBorder(bevelBorder1);
		JPanel4.setLayout(new BoxLayout(JPanel4,BoxLayout.X_AXIS));
		JPanel3.add(BorderLayout.WEST, JPanel4);
		status_mode_msg.setText("  Idle  ");
		status_mode_msg.setToolTipText("<html>Shows the current mode of operation</html>");
		JPanel4.add(status_mode_msg);
		status_mode_msg.setForeground(java.awt.Color.black);
		status_mode_msg.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel5.setAlignmentY(0.466667F);
		JPanel5.setBorder(bevelBorder1);
		JPanel5.setLayout(new BoxLayout(JPanel5,BoxLayout.X_AXIS));
		JPanel3.add(BorderLayout.CENTER, JPanel5);
		JPanel5.setBackground(new java.awt.Color(204,204,204));
		regular_status_msg.setToolTipText("<html>Displays messages from the system</html>");
		JPanel5.add(regular_status_msg);
		regular_status_msg.setForeground(java.awt.Color.black);
		regular_status_msg.setFont(new Font("Dialog", Font.PLAIN, 12));
		loggedInUserPanel.setAlignmentY(0.466667F);
		loggedInUserPanel.setBorder(bevelBorder1);
		loggedInUserPanel.setToolTipText("<html>Shows the user that is logged in to ASSET Manager</html>");
		loggedInUserPanel.setLayout(new BoxLayout(loggedInUserPanel,BoxLayout.X_AXIS));
		JPanel3.add(BorderLayout.EAST, loggedInUserPanel);
		current_user.setText("Mark McLarnon");
		loggedInUserPanel.add(current_user);
		current_user.setForeground(java.awt.Color.black);
		current_user.setFont(new Font("Dialog", Font.PLAIN, 12));
		//}}   

		current_user.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
		current_user.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		current_user.setText("NIST ASSET Administration");
		current_user.setForeground(java.awt.Color.black);
		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		SymMouse aSymMouse = new SymMouse();
		import_assessment_label.addMouseListener(aSymMouse);
		search_assessments_label.addMouseListener(aSymMouse);
		customize_label.addMouseListener(aSymMouse);
		//}}
        this.workspace.setBackground(Color.white);
		this.right_panel.add(this.workspace);
			
		this.menuTree.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                int selRow = menuTree.getRowForLocation(e.getX(), e.getY());
                TreePath tp = menuTree.getPathForLocation(e.getX(), e.getY());
                if(selRow != -1) {
		            DefaultMutableTreeNode ques = (DefaultMutableTreeNode) tp.getLastPathComponent();
	 	            internal_setCursor("wait");
	    
		            String win = (String) ques.getUserObject();
		            displayWindow(win);
		            internal_setCursor("default");
                }
            }
        });
	}

    public void openOldAssessment(String id, String name) {
        try {
	        this.assessment = new AssessmentWindow(this);
            this.assessment.setClosable(true);
	        this.assessment.setMaximizable(true);	        
	        this.assessment.setSecondaryAssessor(this.primary_assessor);
	        this.assessment.extractFromDatabase(id, name);
            workspace.add(this.assessment);
            this.assessment.setMaximum(true);
	        this.assessment.setVisible(true);	             
        }catch (Exception e) {
            e.printStackTrace();
        }
    }/* end method openOldAssessment(String, String) */

    public ASSETPropertyManager getPropertyManager() {
        return this.props;           
    }

    // This method is responsible for starting a new assessment. It utilizes the asset.jar 
    // java archive and therefor the script that starts the ASSET Manager application must 
    // have this jar accessible within the classpath. 
    // ---------------
    // Change Control:
    // 05/09/02 - Added code to set the closable and maximizable properties of this 
    //            instance of AssessmentWindow to false to keep in line with the 
    //            other instance of JInternalFrame like the reporting window and 
    //            the search for assessments window.
    // 05/13/02 - Removed code that set maximizable/resizable property to false. Clients should
    //            be able to resize the assessment window during an assessment.
    public void startNewAssessment() {
        try {
	        this.assessment = null;
	        this.setStatusModeMsg(" AIP ");
	        this.setStatusModeMsg("Creating new assessment window now, please hold.");
	        this.assessment = new AssessmentWindow(this);
	        this.assessment.setClosable(true);
	        this.assessment.setPrimaryAssessor(this.primary_assessor, this.primary_assessor.getDataVector());
            workspace.add(this.assessment);
            this.assessment.setMaximum(true);
	        this.assessment.setVisible(true);	                    
        }catch (Exception e) {
            e.printStackTrace();
        }
    }/* end method startNewAssessment() */
    
    /**
     * Creates a new instance of JFrame1 with the given title.
     * @param sTitle the title for the new frame.
     * @see #JFrame1()
     */
	public SATAdmin(String sTitle) {
		this();
		setTitle(sTitle);
	}
	
	public Connection connectionGenerator() {
        try {
            return DriverManager.getConnection(this.props.getProperty("sat.data.connstring"), this.props.getProperty("sat.data.username"), this.props.getProperty("sat.data.password"));
        }catch (Exception e) {
            e.printStackTrace();
            this.displayErrorDialog("Cannot connect to ASSET Manager database! ASSET Manager will now exit.");
            System.exit(1);
        }
        return null;
    }  	
    
	public void displayErrorDialog(String msg) {
        try {
            JOptionPane.showMessageDialog(this, msg, "Error:", JOptionPane.ERROR_MESSAGE);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
    
	public void displayStatusDialog(String msg) {
        try {
            JOptionPane.showMessageDialog(this, msg, "System Message:", JOptionPane.INFORMATION_MESSAGE);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }        
	
    public void defineAction(String action) {
        this.execute(this.props.getProperty("sat.help.defaultbrowser") + " " + this.getFullPath(this.props.getProperty("sat.help.actiondocument"))+ "#" + action);        
    }
    
    public void openManagerHelp() {
        this.execute(this.props.getProperty("sat.help.defaultbrowser") + " " + this.getFullPath(this.props.getProperty("sat.manager.help.defaultdocument")));        
    }
    
    public void defineTerm(String term) {
        this.execute(this.props.getProperty("sat.help.defaultbrowser") + " " + this.getFullPath(this.props.getProperty("sat.help.definitiondocument"))+ "#" + term);                
    }
    
    private void execute(String cmd) {
        try {            
             Runtime subsystem = Runtime.getRuntime();
             if (this.checkDefaultBrowserSet()) {
                 subsystem.exec(cmd);
             }else {
                ChooseBrowserWizard wiz = ChooseBrowserWizard.spawnNewChooseBrowserWizard(this, this.props);                
             }
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

    public boolean checkDefaultBrowserSet() {
        boolean flag = true;
        try {
            if (props.getProperty("sat.help.defaultbrowser") == null) {
                flag = false;
            }
            
        }catch (Exception e) {
            e.printStackTrace();
        }
        return flag;
    }
    
    public boolean verifyDefaultBrowserSet() {
        try {
            if (props.getProperty("sat.help.defaultbrowser") == null) {
                {
                    this.displayErrorDialog("You have not specified a default browser!");    
                }
                return false;                
            }
        }catch (Exception e) {
            e.printStackTrace();
        }
        return true;
    }    
    
    public void setNewDefaultBrowser() {
        try {
            ChooseBrowserWizard wiz = ChooseBrowserWizard.spawnNewChooseBrowserWizard(this, this.props);            
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String getFullPath(String local_path) {
        StringBuffer file_name = new StringBuffer("");
        try {
            file_name.append((symantec.itools.net.RelativeURL.getURL(local_path)).toString());
        }catch (Exception e) {
            e.printStackTrace();
        }
        return file_name.toString();
    }
    
    public String getAbsolutePath(String local_path) {
        StringBuffer file_name = new StringBuffer("");
        try {
            file_name.append(System.getProperty("user.dir") + File.separator + local_path);
        }catch (Exception e) {
            e.printStackTrace();
        }
        return file_name.toString();        
    }

    public void openDefaultHelpFile() {
        try {
           Runtime subsystem = Runtime.getRuntime();
           
           if (this.verifyDefaultBrowserSet()) {
               subsystem.exec(this.props.getProperty("sat.help.defaultbrowser") + " " + getFullPath(this.props.getProperty("sat.help.defaultdocument")));
           }else {
               this.checkDefaultBrowserSet(); 
           }
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void setActiveTextComponent(JTextComponent component) {
    }
	
    public void buildMenu() {
        Vector cache_data = null;
        try {
            this.logger.log("checking to see if menu data already exists...");
            File check_exists = new File(this.props.getProperty("admin.menu.path"));
            if (check_exists.exists()) {
                this.logger.log("menu data exists, using pre-cached menu data to speed computation");
                
                FileInputStream fis = new FileInputStream(this.props.getProperty("admin.menu.path"));
                ObjectInputStream ois = new ObjectInputStream(fis);

                cache_data = (Vector) ois.readObject();
              
                this.menu_model = (DefaultTreeModel) cache_data.elementAt(0);
                this.menuTree.setCellRenderer(custom_renderer);
                this.menuTree.setModel(this.menu_model);
                                                                
                ois.close();                                               
                this.logger.log("completed building assessment map, please hold");
            }else {
                this.logger.log("map menu does not exist, rebuilding map from scratch");
                this.rebuildMenu();
            }
        }catch (Exception e) {
            this.logger.log(e.toString());
        }
    }
    
    // The logic that builds the action menu for the user interface. With this menu users 
    // decide what the will do just like the Microsoft MMC. In order for the menu to be
    // displayed correctly the MenuCellRenderer class must be accessible to the compiler and
    // in the final binary archive.
    public void rebuildMenu() {
        DefaultMutableTreeNode new_assessment_node = null;
        DefaultMutableTreeNode assessment_node = null;
        DefaultMutableTreeNode import_node = null;
        DefaultMutableTreeNode rpt_node = null;
        DefaultMutableTreeNode help_node = null;
        DefaultMutableTreeNode brws_node = null;
        DefaultMutableTreeNode about_node = null;
        int node_count = 0;
        
        int assessment_count = 0;
        int question_count = 0;
        int rprt_count = 0;
        int help_count = 0;
        Vector cache_data = new Vector();
        try {
            this.root_node = new DefaultMutableTreeNode("ASSET Manager Actions");
            this.menu_model = new DefaultTreeModel(this.root_node);
             
            this.menuTree.setCellRenderer(this.custom_renderer);
             
            assessment_node = new DefaultMutableTreeNode("Search for assessments");
            new_assessment_node = new DefaultMutableTreeNode("Create new assessment");
            rpt_node = new DefaultMutableTreeNode("Generate reports");
            help_node = new DefaultMutableTreeNode("Help");
            brws_node = new DefaultMutableTreeNode("Change default browser");
            about_node = new DefaultMutableTreeNode("About ASSET Manager");           
             
            this.menu_model.insertNodeInto(assessment_node, this.root_node, node_count);
            node_count++;  
            
            this.menu_model.insertNodeInto(new_assessment_node, this.root_node, node_count);
            node_count++;              

            this.menu_model.insertNodeInto(rpt_node, this.root_node, node_count);
            node_count++;         
            
            this.menu_model.insertNodeInto(help_node, this.root_node, node_count);
            node_count++;
            
            this.menu_model.insertNodeInto(brws_node, help_node, help_count);
            help_count++;    
            
            this.menu_model.insertNodeInto(about_node, help_node, help_count);
            help_count++;  
                                    
            cache_data.addElement(this.menu_model);

            FileOutputStream fos = new FileOutputStream(this.props.getProperty("admin.menu.path"));
            ObjectOutputStream oos = new ObjectOutputStream(fos);
            oos.writeObject(cache_data);
            oos.close();
            
            this.menuTree.setModel(this.menu_model);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
	
	/**
	 * The entry point for this application.
	 * Sets the Look and Feel to the System Look and Feel.
	 * Creates a new JFrame1 and makes it visible.
	 */
	static public void main(String args[]) {
		try {
		    // Add the following code if you want the Look and Feel
		    // to be set to the Look and Feel of the native system.
            SATAdmin admin = new SATAdmin();
            try {
		        UIManager.setLookAndFeel(new String(admin.props.getProperty("sat.display.defaultplaf"))); 
		    }catch (Exception e) { 
                admin.displayErrorDialog("ERROR: cannot set user interface to Metal look");
                e.printStackTrace();
                System.exit(1);
		    }
		    
			splash = new AdminSplashScreen();
			admin.internal_setCursor("wait");
			splash.setImageLocation(admin.props.getProperty("sat.splashscreen.imagepath"));
            splash.center();
            splash.setVisible(true);
            admin.openAssessmentWindow();
            try {
                Thread.sleep(4000);  
            }catch (Exception e) {
                e.printStackTrace();
            }
			splash.setVisible(false);
			
			splash.dispose();
			admin.login = new AdminLoginDialog(admin);
			admin.login.setVisible(true);
			
			admin.internal_setCursor("hand");					
		}catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}/* end main(String[]) */


	// This method is designed to encapsulate changing the cursor type
	// it is used to show the user that an action is occurring that needs 
	// to pause for.
	private void internal_setCursor(String cursor_type) {
	    try {
	        if (cursor_type.equals("wait")) {
                this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.WAIT_CURSOR));
	        }else  if (cursor_type.equals("hand")) {
	            this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
	        }else  if (cursor_type.equals("default")) {
	            this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
	        }
	    }catch (Exception e) {
	        this.logger.log(e.toString());
	    }
	}
	
	public void setStatusMsg(String msg) {
        StringBuffer message_buffer = new StringBuffer();
        try {
            this.regular_status_msg.setText(" ");
            message_buffer.append("  ");
            message_buffer.append(msg);
            this.regular_status_msg.setText(message_buffer.toString());
            Graphics g = this.regular_status_msg.getGraphics();
            this.regular_status_msg.update(g);
        }catch (Exception e) {
            e.printStackTrace();
        }
	}
	
	public void setStatusModeMsg(String msg) {
        StringBuffer message_buffer = new StringBuffer();
        try {
            this.status_mode_msg.setText("      ");
            int length = msg.length();
            
            for (int i = 0; i < (6-length); i++) {
               message_buffer.append(" ");
            }
            message_buffer.append(msg);
            this.status_mode_msg.setText(message_buffer.toString());
            Graphics g = this.status_mode_msg.getGraphics();
            this.status_mode_msg.update(g);
        }catch (Exception e) {
            e.printStackTrace();
        }
	}	
	
	public void setPrimaryAssessor(Assessor primary) {
        this.primary_assessor = primary;
        this.current_user.setText(" " + primary.getFullName() + " ");
	}	
	
    /**
     * Notifies this component that it has been added to a container
     * This method should be called by <code>Container.add</code>, and 
     * not by user code directly.
     * Overridden here to adjust the size of the frame if needed.
     * @see java.awt.Container#removeNotify
     */
	public void addNotify() {
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();
		
		super.addNotify();
		
		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;
		
		// Adjust size of frame according to the insets and menu bar
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
		    menuBarHeight = menuBar.getPreferredSize().height;
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	com.symantec.itools.javax.swing.icons.ImageIcon newIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon openIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon saveIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon cutIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon copyIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon pasteIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon aboutIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	com.symantec.itools.javax.swing.JSplitPaneWrapper JSplitPaneWrapper1 = new com.symantec.itools.javax.swing.JSplitPaneWrapper();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JTree menuTree = new javax.swing.JTree();
	javax.swing.JPanel right_panel = new javax.swing.JPanel();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder1 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	com.symantec.itools.javax.swing.borders.EtchedBorder etchedBorder1 = new com.symantec.itools.javax.swing.borders.EtchedBorder();
	com.symantec.itools.javax.swing.borders.EmptyBorder emptyBorder1 = new com.symantec.itools.javax.swing.borders.EmptyBorder();
	com.symantec.itools.javax.swing.icons.ImageIcon importIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon searchIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon questionIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon imageIcon4 = new com.symantec.itools.javax.swing.icons.ImageIcon();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel4 = new javax.swing.JPanel();
	javax.swing.JLabel status_mode_msg = new javax.swing.JLabel();
	javax.swing.JPanel JPanel5 = new javax.swing.JPanel();
	javax.swing.JLabel regular_status_msg = new javax.swing.JLabel();
	javax.swing.JPanel loggedInUserPanel = new javax.swing.JPanel();
	javax.swing.JLabel current_user = new javax.swing.JLabel();
	//}}
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel7 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel9 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel10 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel11 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel8 = new javax.swing.JPanel();	
	javax.swing.JPanel JPanel6 = new javax.swing.JPanel();	
	HTMLLabel import_assessment_label = new HTMLLabel();
	HTMLLabel search_assessments_label = new HTMLLabel();
	HTMLLabel customize_label = new HTMLLabel();
	AssessmentWindow assessment = null;
	
	JDesktopPane workspace = new JDesktopPane();
    Assessor primary_assessor = null;
    LogWindow logger = new LogWindow();
    static AdminSplashScreen splash = null;
    AdminLoginDialog login = null;
    DefaultTreeModel menu_model = null;
    MenuCellRenderer custom_renderer = new MenuCellRenderer();
    static ASSETManagerPropertyManager props = null;
    DefaultMutableTreeNode root_node = null;
    
    AssessmentFrame aFrame = null;
    ReportingFrame rFrame  = null;
    QuestionFrame qFrame = null;
    
    boolean aFrameopened = false;
    boolean rFrameopened = false;
    boolean qFrameopened = false;
    
	//{{DECLARE_MENUS
	//}}
	
	public void openReportingFrame() {
	    try {
            this.displayWindow("Generate reports");        
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
	public void log(String value) {
	    this.logger.log(value);    
	}
	
	public void setServiceName(String name) {
	    this.logger.setServiceName(name);    
	}
	
	public void saveLogOnException() {
	    
	}

    private void openAssessmentWindow() {
        try {
            if (!aFrameopened) {
                this.setStatusModeMsg("SEARCH");
                this.setStatusMsg("Opening assessments window now...");
                aFrame = new AssessmentFrame(this);
                aFrameopened = true;
                this.workspace.add(aFrame);
                aFrame.setVisible(true);
                aFrame.setMaximum(true);
                this.setStatusMsg("");
            }else {
                aFrame.setVisible(true);
                aFrame.setMaximum(true);                    
            }            
        }catch (Exception e) {
            e.printStackTrace();
            this.displayErrorDialog("ERROR: cannot open assessment search window!");
        }
    }

    // This method is the action handler for the valueChanged() method. When a user clicks
    // on one of the elements in the action menu for ASSET Manager the valueChanged method 
    // will always call this method passing in the param @win the string value of the item
    // the user clicked on.
    // ---------------
    // Change Control:
    // 05/09/02 - Changed else bloock of if/then statement that checks to see if the user clicked
    //            on the "Search for assessments" window. It now matches the else block of the
    //            reporting block. This causes the menu to function as an opener for those windows
    //            that are not open to begin with and also to switch between those windows that 
    //            are opened.
    // 05/10/02 - Added code to set all other windows visibility state to false when the user clicks
    //            on a particular window in the left hand menu of ASSET Manager.
    // 05/20/02 - Added code to set the selected index of the reporting frame to the first tab
    //            when the frame is displayed again.
    public void displayWindow(String win) {
        try {
            if (win.equals("Search for assessments")) {
                if (!aFrameopened) {
                    this.setStatusModeMsg("SEARCH");
                    this.setStatusMsg("Opening assessments window now...");
                    aFrame = new AssessmentFrame(this);
                    aFrameopened = true;
                    this.workspace.add(aFrame);
                    aFrame.setVisible(true);
                    aFrame.setMaximum(true);
                    this.setStatusMsg("");
                }else {
                    this.setStatusModeMsg("SEARCH");
                    aFrame.setMaximum(true); 
                    aFrame.setVisible(true);
                    if (rFrame != null) {
                        rFrame.setVisible(false);
                    }
                    if (assessment != null) {
                        assessment.setVisible(false);
                    }
                }
            }
            if (win.equals("Generate reports")) {
                if (!rFrameopened) {
                    this.setStatusModeMsg("RPRT");
                    rFrame  = ReportingFrame.spawnReportingWindow(this);
                    rFrameopened = true;
                    rFrame.setReportCreator(this.primary_assessor);
                    this.workspace.add(rFrame);
                    rFrame.setClosable(false);
                    rFrame.setVisible(true);
                    rFrame.setMaximum(true);
                    rFrame.clearResultsTable();
                    this.setStatusMsg("");
                }else {
                    if (rFrame != null) {
                        this.setStatusModeMsg("RPRT");
                        rFrame.setMaximum(true);
                        rFrame.setVisible(true);
                        rFrame.JTabbedPane1.setSelectedIndex(0);
                        rFrame.clearResultsTable();
                    }else {
                        this.setStatusModeMsg("RPRT");
                        rFrame  = ReportingFrame.spawnReportingWindow(this);
                        rFrameopened = true;
                        rFrame.setClosable(false);
                        rFrame.setReportCreator(this.primary_assessor);
                        this.workspace.add(rFrame);
                        rFrame.setVisible(true);
                        rFrame.setMaximum(true);
                        this.setStatusMsg("");  
                        rFrame.clearResultsTable();
                    }
                    if (aFrame != null) {
                        aFrame.setVisible(false);
                    }
                    if (assessment != null) {
                        assessment.setVisible(false);
                    }                    
                }
            }
            if (win.equals("Change default browser")) {
                this.setNewDefaultBrowser();
            }
            if (win.equals("Help")) {
                this.setStatusModeMsg("HELP");
                this.setStatusMsg("Opening ASSET Manager Help files now...");
                this.openManagerHelp();
                this.setStatusModeMsg("Idle...");
                this.setStatusMsg("");
            }             
            if (win.equals("Create new assessment")) {
                this.setStatusModeMsg(" AIP ");
                this.setStatusMsg("Creating new assessment now, please hold...");
                this.startNewAssessment();
                this.setStatusMsg("");
            }     
            if (win.equals("About ASSET Manager")) {
                AdminSplashScreen splash = new AdminSplashScreen();
			    splash.setImageLocation(this.props.getProperty("sat.splashscreen.imagepath"));
                splash.center();
                splash.setVisible(true);
            } 
        }catch (Exception e) {
            e.printStackTrace();
        }
    }/* end method displayWindow(String) */

    // THis method implements the TreeSelectionListener interface for the SATAdmin 
    // class. When a user selects a value from the navigation menu on the left side of the
    // ASSET Manager interface, this method gets called. The action that the user 
    // selects is then passed to the displayWindow() method which will decide what 
    // to do.
    // -----------
    // Change Control:
    // 04/09/02 - Added check to see if TreePath value was null. This is the case 
    //            when an action is performed on the menu tree other than selecting a valid
    //            node
    public void valueChanged(TreeSelectionEvent tse) {        
        String value = "";
        this.workspace.setVisible(true); 
        try {
            TreePath tp = tse.getNewLeadSelectionPath();
            if (tp != null) {
		        DefaultMutableTreeNode ques = (DefaultMutableTreeNode) tp.getLastPathComponent();
	 	        this.internal_setCursor("wait");
	    
		        String win = (String) ques.getUserObject();
		        this.displayWindow(win);
		        this.internal_setCursor("default");
		    }
		}catch (Exception e) {
		    e.printStackTrace();
		}
	}/* end method valueChanged() */    

	void exitApplication() {
		try {
	    	// Beep
	    	Toolkit.getDefaultToolkit().beep();
	    	// Show a confirmation dialog
		    this.setVisible(false);    // hide the Frame
		    this.dispose();            // free the system resources
		    System.exit(0);            // close the application
		} catch (Exception e) {
		    e.printStackTrace();		    
		}
	}

	class SymWindow extends java.awt.event.WindowAdapter {
		public void windowDeiconified(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == SATAdmin.this)
				SATAdmin_windowDeiconified(event);
		}

	    
		public void windowClosing(java.awt.event.WindowEvent event) {
			Object object = event.getSource();
			if (object == SATAdmin.this)
				SATAdmin_windowClosing(event);
		}
	}

	void SATAdmin_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
			 
		SATAdmin_windowClosing_Interaction1(event);
	}

	void SATAdmin_windowClosing_Interaction1(java.awt.event.WindowEvent event) {
		try {
			this.exitApplication();
		} catch (Exception e) {
		    ;
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			
		}
	}

	class SymMouse extends java.awt.event.MouseAdapter {
		public void mouseExited(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == import_assessment_label)
				importAssessmentLabel_mouseExited(event);
		}

		public void mouseEntered(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == import_assessment_label)
				importAssessmentLabel_mouseEntered(event);
		}
	}/* end internal class SymMouse */

	void importAssessmentLabel_mouseEntered(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		import_assessment_label_mouseEntered_Interaction1(event);
	}

	void import_assessment_label_mouseEntered_Interaction1(java.awt.event.MouseEvent event)
	{
		try {
		    this.internal_setCursor("hand");
			import_assessment_label.rollover_enter();
		} catch (java.lang.Exception e) {
		}
	}

	void importAssessmentLabel_mouseExited(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		import_assessment_label_mouseExited_Interaction1(event);
	}

	void import_assessment_label_mouseExited_Interaction1(java.awt.event.MouseEvent event)
	{
		try {
			import_assessment_label.rollover_exit();
			this.internal_setCursor("default");
		} catch (java.lang.Exception e) {
		}
	}

	void SATAdmin_windowDeiconified(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
	}
}/* end class SATAdmin.java() */
