-- Stored Procedure - 
-- ASSET Component - ASSET Manager
-- Purpose - 
-- Author - Mark McLarnon
-- CHANGE LOG:
-- 11/8/02 Added explicit reference to components.assessment_id in "SET @component_num..." line because if the same component
--         name was in the database twice. This line would originally have returned more than one result. If the reference to 
--         the assessment_id was not added.
create procedure delete_saved_assessment
(
@assessment_id     varchar(100),
@component_name    varchar(50),
@start_timestamp   varchar(50)
)
AS
DECLARE @component_num    varchar(100)

SET @component_num = (SELECT components.component_num FROM components WHERE components.component_name = @component_name AND components.assessmentid = @assessment_id)

EXECUTE delete_connected_components @assessment_id, @component_num

EXECUTE delete_component_criticality @assessment_id, @component_num

EXECUTE delete_question_responses @assessment_id

EXECUTE delete_assessor_accountability @assessment_id

EXECUTE delete_component_information @assessment_id, @component_num

EXECUTE delete_assessment_information @assessment_id

GO