-- Stored Procedure - 
-- ASSET Component - ASSET Manager
-- Purpose - 
-- Author - Mark McLarnon
create procedure get_single_saved_assessment
(
    @component_name    varchar(50),
    @start_timestamp   varchar(40)
)
AS
SELECT 
    components.component_name AS component_name, 
    components.component_num AS component_num, 
    components.location AS component_location, 
    components.component_type AS component_type, 
    components.assessment_obj AS component_assessment_obj,
    assessments.assessment_id AS assessment_id,
    assessments.start_timestamp AS start_timestamp, 
    assessments.completed, assessments.bookmark, 
    assessments.primary_assessor,
    assessments.progress
FROM 
    assessments 
INNER JOIN 
    components 
ON 
    assessments.assessment_id=components.assessment_id
WHERE 
    components.component_name = @component_name 
AND 
    assessments.start_timestamp = @start_timestamp 
ORDER BY components.component_name
GO