-- Stored Procedure - 
-- ASSET Component - ASSET Manager
-- Purpose - 
-- Author - Mark McLarnon
create procedure query_single_saved_assessment
(
    @assessment_id    varchar(100)
)
AS
SELECT 
    components.component_name AS component_name, 
    components.component_num AS component_num, 
    components.location AS component_location, 
    components.component_type AS component_type, 
    components.assessment_obj AS component_assessment_obj, 
    assessments.assessment_id, 
    assessments.start_timestamp, 
    assessments.completed, 
    assessments.bookmark, 
    assessments.primary_assessor
FROM 
    assessments 
INNER JOIN 
    components 
ON 
    assessments.assessment_id = components.assessment_id
WHERE 
    assessments.assessment_id = @assessment_id
ORDER BY 
    components.component_name
GO