-- Stored Procedure - 
-- ASSET Component - ASSET Manager
-- Purpose - 
-- Author - Mark McLarnon
create procedure save_answered_question
(
 @full_name       varchar(50),
 @assessment_id   varchar(100),
 @major_section   integer,
 @minor_section   integer,
 @question_number integer,
 @version         integer
)
AS
IF (NOT EXISTS (SELECT * from assessors where assessment_id = @assessment_id AND major_section = @major_section AND minor_section = @minor_section AND question_number = @question_number AND version = @version))
BEGIN 
    INSERT INTO assessors
    (
        [full_name], 
	[assessment_id], 
	[major_section], 
	[minor_section], 
	[question_number], 
	[version]
    )VALUES 
    (
	@full_name, 
	@assessment_id, 
	@major_section, 	
	@minor_section, 
	@question_number, 
	@version
    )
END
ELSE
    UPDATE assessors
        SET full_name = @full_name,
	    version = @version
    WHERE assessment_id   = @assessment_id
    AND   major_section   = @major_section
    AND   minor_section   = @minor_section
    AND   question_number = @version
GO