-- Stored Procedure - 
-- ASSET Component - ASSET Manager
-- Purpose - 
-- Author - Mark McLarnon
create procedure save_component_criticalities
(
    @assessment_id    varchar(100),
    @component_num    varchar(100),
    @confidentiality  char(30),
    @integrity        char(30),
    @availability     char(30)
)

AS

IF (NOT EXISTS (SELECT * FROM component_criticality WHERE assessment_id = @assessment_id AND component_num = @component_num))
BEGIN
    INSERT INTO component_criticality
    (
	[assessment_id], 
	[component_num], 
	[confidentiality], 
	[integrity], 
	[availability]
    )
    VALUES 
    (
	@assessment_id, 
	@component_num, 
	@confidentiality, 
	@integrity, 
	@availability
    )
END
ELSE
    UPDATE component_criticality
    SET confidentiality = @confidentiality,
        integrity       = @integrity,
        availability    = @availability
    WHERE assessment_id = @assessment_id
    AND   component_num = @component_num
GO