-- Stored Procedure - 
-- ASSET Component - ASSET Manager
-- Purpose - 
-- Author - Mark McLarnon
create procedure save_connected_components
(
@assessment_id    varchar(100),
@component_num    varchar(100),
@conn_component   varchar(50),
@bce              integer,
@planned_action   varchar(255)
)
AS
IF (NOT EXISTS (SELECT * FROM conn_components WHERE component_num = @component_num AND conn_component = @conn_component AND assessment_id = @assessment_id))
BEGIN
    INSERT INTO conn_components
    (
	[assessment_id],
        [component_num], 
        [conn_component], 
        [bce], 
        [planned_action]
    )
    VALUES 
    (
	@assessment_id,
	@component_num, 
	@conn_component, 
	@bce, 
	@planned_action
    )
END
ELSE
    UPDATE conn_components
    SET bce = @bce,
        planned_action = @planned_action
    WHERE 
	component_num = @component_num
    AND   
	conn_component = @conn_component
    AND
	assessment_id = @assessment_id
GO