-- Stored Procedure - 
-- ASSET Component - ASSET Manager
-- Purpose - 
-- Author - Mark McLarnon
create procedure get_all_assessment_information
AS
SELECT 
    assessments.assessment_id,
    assessments.completed,
    assessments.primary_assessor,
    components.component_num,
    components.location,
    components.component_name,
    components.component_type,
    component_criticality.confidentiality,
    component_criticality.integrity,
    component_criticality.availability 
FROM
(
    assessments
INNER JOIN 
    components
ON 
    assessments.assessment_id = components.assessment_id
)
INNER JOIN
    component_criticality
ON
    components.component_num = component_criticality.component_num
AND
    components.assessment_id = component_criticality.assessment_id
AND
    assessments.active = 1
AND    
    components.active = 1
GO