-- Stored Procedure - 
-- ASSET Component - ASSET Manager
-- Purpose - 
-- Author - Mark McLarnon
create procedure get_question_results_per_section
(
    @assessment_id     varchar(100),
    @critical_major    integer,
    @critical_minor    integer,
    @critical_number   integer
)
AS
SELECT  	
	assessment_question_responses.major_section AS major_section,
	assessment_question_responses.minor_section AS minor_section,
	assessment_question_responses.question_number AS question_number,
	assessment_question_responses.level1 AS level1,
	assessment_question_responses.level2 AS level2,
	assessment_question_responses.level3 AS level3,
	assessment_question_responses.level4 AS level4,
	assessment_question_responses.level5 AS level5,
	rbdm,
	cmnts,
	ar,
        na,
	reviewer,
	completed,
	assessors.full_name AS full_name
FROM 
  	assessment_question_responses 
	INNER JOIN 
	    assessors 
	ON 
	    assessment_question_responses.assessment_id = assessors.assessment_id
	AND
	    assessment_question_responses.major_section = assessors.major_section
	AND
	    assessment_question_responses.minor_section = assessors.minor_section
	AND
	    assessment_question_responses.question_number = assessors.question_number
	WHERE
	    assessment_question_responses.assessment_id   = @assessment_id
	AND
	    assessment_question_responses.major_section   = @critical_major
	AND
	    assessment_question_responses.minor_section   = @critical_minor
GO