/********************************************************************************/
/* file - ClientReportingFrame.java                                             */
/* --------------------------                                                   */
/* This class implements the user interface for presenting reports within the   */
/* administration tool.                                                         */
/* --------------------------                                                   */
/* NIST Self-Assessment Tool                                                    */
/* Author - Mark McLarnon                                                       */
/* --------------------------                                                   */
/* Change Control:                                                              */
/* 06/13/02 - Set default file name for when exporting results.                 */
/********************************************************************************/
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.table.*;
import java.sql.*;
import java.io.*;
import com.symantec.itools.javax.swing.borders.EmptyBorder;
import com.symantec.itools.javax.swing.icons.ImageIcon;
import com.symantec.itools.javax.swing.borders.EtchedBorder;
import com.symantec.itools.javax.swing.JChart;
import com.symantec.itools.javax.swing.models.StringComboBoxModel;
import com.symantec.itools.javax.swing.models.StringTableModel;
import com.symantec.itools.javax.swing.borders.BevelBorder;
import com.symantec.itools.javax.swing.JSplitPaneWrapper;
import com.symantec.itools.javax.swing.actions.JActionButton;
import com.symantec.itools.javax.swing.JWrappingLabel;


public class ClientReportingFrame extends javax.swing.JInternalFrame implements ASSETChild {

	public ClientReportingFrame() {
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setIconifiable(true);
		setMaximizable(true);
		setTitle("ASSET Reporting");
		setResizable(true);
		setAlignmentY(0.0F);
		setAlignmentX(0.0F);
		try {
			setSelected(true);
		}
		catch(java.beans.PropertyVetoException e) { }
		setClosable(true);
		setToolTipText("<html>ASSET System Reporting Window</html>");
		setDefaultCloseOperation(javax.swing.JFrame.DISPOSE_ON_CLOSE);
		getContentPane().setLayout(new BoxLayout(this.getContentPane(),BoxLayout.X_AXIS));
		setSize(725,473);
		try {
			reportIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/report.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ reportIcon.move(24,474);
		JPanel1.setLayout(new BorderLayout(0,0));
		getContentPane().add(JPanel1);
		JScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
		JScrollPane1.setOpaque(true);
		JPanel1.add(BorderLayout.CENTER, JScrollPane1);
		JPanel3.setAlignmentY(0.0F);
		JPanel3.setLayout(new BorderLayout(0,0));
		JScrollPane1.getViewport().add(JPanel3);
		JPanel3.setBounds(0,0,722,470);
		JPanel16.setAlignmentY(0.444444F);
		JPanel16.setLayout(new BoxLayout(JPanel16,BoxLayout.X_AXIS));
		JPanel3.add(BorderLayout.NORTH, JPanel16);
		JToolBar1.setAlignmentY(0.478261F);
		JPanel16.add(JToolBar1);
		JButton2.setDefaultCapable(false);
		JButton2.setToolTipText("<html>Save results to file</html>");
		JToolBar1.add(JButton2);
		JButton3.setDefaultCapable(false);
		JButton3.setToolTipText("<html>Set active assessment</html>");
		JToolBar1.add(JButton3);
		JButton4.setActionCommand("creatingreports");
		JButton4.setDefaultCapable(false);
		JButton4.setToolTipText("<html>Open help on reporting</html>");
		JToolBar1.add(JButton4);
		JPanel3.add(BorderLayout.CENTER, JTabbedPane1);
		JPanel14.setAlignmentY(0.0F);
		JPanel14.setBorder(etchedBorder1);
		JPanel14.setLayout(new BoxLayout(JPanel14,BoxLayout.X_AXIS));
		JTabbedPane1.add(JPanel14);
		JPanel14.setVisible(false);
		JPanel14.add(JSplitPaneWrapper1);
		JPanel17.setAlignmentX(0.497143F);
		JPanel17.setLayout(new BoxLayout(JPanel17,BoxLayout.Y_AXIS));
		JSplitPaneWrapper1.add(JPanel17);
		JPanel10.setLayout(new FlowLayout(FlowLayout.LEFT,5,0));
		JPanel17.add(JPanel10);
		JLabel6.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
		JLabel6.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		JLabel6.setText("Active System Information:");
		JPanel10.add(JLabel6);
		JLabel6.setForeground(java.awt.Color.black);
		JPanel11.setLayout(new GridLayout(2,1,0,0));
		JPanel17.add(JPanel11);
		JLabel4.setText("System Name:");
		JPanel11.add(JLabel4);
		JLabel4.setForeground(java.awt.Color.black);
		JLabel4.setFont(new Font("Dialog", Font.BOLD, 12));
		system_name_label.setText("No active system specified");
		JPanel11.add(system_name_label);
		system_name_label.setForeground(java.awt.Color.black);
		system_name_label.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel25.setLayout(new GridLayout(2,1,0,0));
		JPanel17.add(JPanel25);
		JLabel14.setText("System Number:");
		JPanel25.add(JLabel14);
		JLabel14.setForeground(java.awt.Color.black);
		system_number_field.setText("No number specified");
		JPanel25.add(system_number_field);
		system_number_field.setForeground(java.awt.Color.black);
		system_number_field.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel12.setLayout(new GridLayout(2,1,0,0));
		JPanel17.add(JPanel12);
		JLabel7.setText("Assessment Start Date:");
		JPanel12.add(JLabel7);
		JLabel7.setForeground(java.awt.Color.black);
		JLabel7.setFont(new Font("Dialog", Font.BOLD, 12));
		system_date_label.setText("No date specified");
		JPanel12.add(system_date_label);
		system_date_label.setForeground(java.awt.Color.black);
		system_date_label.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel18.setLayout(new GridLayout(2,1,0,0));
		JPanel17.add(JPanel18);
		JLabel8.setText("System Identifier:");
		JPanel18.add(JLabel8);
		JLabel8.setForeground(java.awt.Color.black);
		JLabel8.setFont(new Font("Dialog", Font.BOLD, 12));
		try {
			system_id_label.setText("No identifier specified");
		}
		catch(java.beans.PropertyVetoException e) { }
		JPanel18.add(system_id_label);
		JPanel19.setBorder(emptyBorder1);
		JPanel19.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		JPanel17.add(JPanel19);
		JButton1.setText("Change Active System");
		JButton1.setActionCommand("Change Active System");
		JPanel19.add(JButton1);
		JPanel33.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		JPanel17.add(JPanel33);
		JPanel35.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		JPanel17.add(JPanel35);
		JPanel34.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		JPanel17.add(JPanel34);
		JPanel2.setBorder(report_pane_border);
		JPanel2.setLayout(new BoxLayout(JPanel2,BoxLayout.X_AXIS));
		JSplitPaneWrapper1.add(JPanel2);
		JPanel2.setBounds(182,1,530,410);
		JPanel4.setLayout(new GridLayout(10,1,0,20));
		JPanel2.add(JPanel4);
		JLabel1.setText("Available Reports:");
		JPanel4.add(JLabel1);
		JLabel1.setForeground(java.awt.Color.black);
		JPanel9.setLayout(new BorderLayout(0,0));
		JPanel4.add(JPanel9);
		JPanel9.add(BorderLayout.WEST, JLabel5);
		JPanel8.setLayout(new BorderLayout(0,0));
		JPanel4.add(JPanel8);
		JPanel8.add(BorderLayout.WEST, JLabel2);
		JPanel6.setLayout(new BorderLayout(0,0));
		JPanel4.add(JPanel6);
		JPanel6.add(BorderLayout.WEST, JLabel3);
		JPanel13.setLayout(new BorderLayout(0,0));
		JPanel4.add(JPanel13);
		JPanel13.add(BorderLayout.WEST, JLabel9);
		JPanel7.setLayout(new GridLayout(2,1,0,0));
		JPanel4.add(JPanel7);
		JPanel7.add(JLabel12);
		JPanel5.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		JPanel2.add(JPanel5);
		JPanel15.setLayout(new BorderLayout(0,0));
		JTabbedPane1.add(JPanel15);
		JPanel15.setBounds(2,24,717,416);
		JPanel15.setVisible(false);
		JPanel20.setBorder(report_header_border);
		JPanel20.setToolTipText("<html>Report headers are listed here</html>");
		JPanel20.setLayout(new GridLayout(6,2,0,5));
		JPanel15.add(BorderLayout.NORTH,JPanel20);
		JPanel21.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel21);
		JLabel11.setText("Report: ");
		JPanel21.add(BorderLayout.WEST, JLabel11);
		JLabel11.setForeground(java.awt.Color.black);
		JPanel21.add(BorderLayout.CENTER, report_name);
		report_name.setForeground(java.awt.Color.black);
		report_name.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel28.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel28);
		JLabel16.setText("Confidentiality:");
		JPanel28.add(BorderLayout.WEST,JLabel16);
		JLabel16.setForeground(java.awt.Color.black);
		JPanel28.add(BorderLayout.CENTER,confidentiality_field);
		confidentiality_field.setForeground(java.awt.Color.black);
		confidentiality_field.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel26.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel26);
		JLabel17.setText("System Name: ");
		JPanel26.add(BorderLayout.WEST, JLabel17);
		JLabel17.setForeground(java.awt.Color.black);
		JPanel26.add(BorderLayout.CENTER, system_name);
		system_name.setForeground(java.awt.Color.black);
		system_name.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel29.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel29);
		JLabel19.setText("Integrity: ");
		JPanel29.add(BorderLayout.WEST,JLabel19);
		JLabel19.setForeground(java.awt.Color.black);
		JPanel29.add(BorderLayout.CENTER,integrity_field);
		integrity_field.setForeground(java.awt.Color.black);
		integrity_field.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel27.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel27);
		JLabel18.setText("System Number: ");
		JPanel27.add(BorderLayout.WEST, JLabel18);
		JLabel18.setForeground(java.awt.Color.black);
		JPanel27.add(BorderLayout.CENTER, system_number);
		system_number.setForeground(java.awt.Color.black);
		system_number.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel30.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel30);
		JLabel20.setText("Availability: ");
		JPanel30.add(BorderLayout.WEST,JLabel20);
		JLabel20.setForeground(java.awt.Color.black);
		JPanel30.add(BorderLayout.CENTER,availability_field);
		availability_field.setForeground(java.awt.Color.black);
		availability_field.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel24.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel24);
		JLabel15.setText("Primary Assessor: ");
		JPanel24.add(BorderLayout.WEST, JLabel15);
		JLabel15.setForeground(java.awt.Color.black);
		JPanel24.add(BorderLayout.CENTER, primary_assessor);
		primary_assessor.setForeground(java.awt.Color.black);
		primary_assessor.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel31.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel31);
		JLabel21.setText("Location: ");
		JPanel31.add(BorderLayout.WEST,JLabel21);
		JLabel21.setForeground(java.awt.Color.black);
		JPanel31.add(BorderLayout.CENTER,location_field);
		location_field.setForeground(java.awt.Color.black);
		location_field.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel22.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel22);
		JLabel13.setText("Today\'s Date:  ");
		JPanel22.add(BorderLayout.WEST, JLabel13);
		JLabel13.setForeground(java.awt.Color.black);
		JPanel22.add(BorderLayout.CENTER, report_generated_date);
		report_generated_date.setForeground(java.awt.Color.black);
		report_generated_date.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel23.setLayout(new BorderLayout(0,0));
		JPanel20.add(JPanel23);
		JLabel10.setText("Totals: ");
		JPanel23.add(BorderLayout.WEST, JLabel10);
		JLabel10.setForeground(java.awt.Color.black);
		totals_label.setText("\\");
		JPanel23.add(BorderLayout.CENTER, totals_label);
		totals_label.setForeground(java.awt.Color.black);
		totals_label.setFont(new Font("Dialog", Font.PLAIN, 12));
		JPanel32.setLayout(new BoxLayout(JPanel32,BoxLayout.X_AXIS));
		JPanel15.add(BorderLayout.CENTER,JPanel32);
		JScrollPane2.setOpaque(true);
		JScrollPane2.setToolTipText("<hmtl>Shows the results of the report you chose</html>");
		JPanel32.add(JScrollPane2);
		report_table.setPreferredScrollableViewportSize(new java.awt.Dimension(250,200));
		JScrollPane2.getViewport().add(report_table);
		report_table.setBounds(0,0,714,0);
		JTabbedPane1.setSelectedIndex(0);
		JTabbedPane1.setSelectedComponent(JPanel14);
		JTabbedPane1.setTitleAt(0,"Choose Report");
		JTabbedPane1.setTitleAt(1,"Tabular Output");
		JPanel17.setBounds(1,1,171,410);
		JPanel14.setBounds(2,24,717,416);
		report_title_label_border.setInsets(new java.awt.Insets(10,10,0,0));
		//$$ report_title_label_border.move(0,474);
		report_pane_border.setInsets(new java.awt.Insets(0,15,0,0));
		//$$ report_pane_border.move(24,474);
		try {
			saveIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/save.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ saveIcon.move(48,474);
		report_header_border.setInsets(new java.awt.Insets(10,10,0,0));
		//$$ report_header_border.move(72,474);
		try {
			helpIcon.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/about.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ helpIcon.move(240,474);
		try {
			imageIcon1.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/preview.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ imageIcon1.move(96,474);
		//$$ etchedBorder1.move(120,474);
		{
			String[] tempString = new String[2];
			tempString[0] = "Bar Graph";
			tempString[1] = "Pie Chart";
			graphic_report_style.setItems(tempString);
		}
		//$$ graphic_report_style.move(144,474);
		//$$ chart_data_model.move(168,474);
		try {
			imageIcon2.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/open.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ imageIcon2.move(192,474);
		emptyBorder1.setInsets(new java.awt.Insets(0,4,4,0));
		//$$ emptyBorder1.move(216,474);
		JButton4.setIcon(helpIcon);
		JLabel5.setIcon(reportIcon);
		JLabel3.setIcon(reportIcon);
		JButton2.setIcon(saveIcon);
		JLabel2.setIcon(reportIcon);
		JLabel9.setIcon(reportIcon);
		JButton3.setIcon(imageIcon2);
		//}}				
		this.na_summary = HTMLLabel.createNewHTMLLabel("List of non-applicable questions");
        this.na_summary.addMouseListener(aSymMouse);
        this.JPanel8.add(BorderLayout.CENTER, this.na_summary);
        
        this.assessment_summary = HTMLLabel.createNewHTMLLabel("List of risk based decisions");
        this.assessment_summary.addMouseListener(aSymMouse);
        this.JPanel6.add(BorderLayout.CENTER, this.assessment_summary); 

        this.topic_summary = HTMLLabel.createNewHTMLLabel("Summary of topic areas by levels of effectiveness");
        this.topic_summary.addMouseListener(aSymMouse);
        this.JPanel9.add(BorderLayout.CENTER, this.topic_summary);         

        this.system_summary = HTMLLabel.createNewHTMLLabel("System Summary");
        this.system_summary.addMouseListener(aSymMouse);
        this.JPanel13.add(BorderLayout.CENTER, this.system_summary);         
        
        this.buildReportMap();  
        this.buildITSAFMap();
        this.prgMonitor = new ProgressDialog();        
	
		//{{REGISTER_LISTENERS
		SymInternalFrame lSymInternalFrame = new SymInternalFrame();
		this.addInternalFrameListener(lSymInternalFrame);
		SymAction lSymAction = new SymAction();
		JButton3.addActionListener(lSymAction);
		JButton2.addActionListener(lSymAction);
		JButton1.addActionListener(lSymAction);
		JButton4.addActionListener(lSymAction);
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		//}}
		fileSaver.addChoosableFileFilter(new TXTFilter());
		fileSaver.setSelectedFile(new File("Untitled.txt"));
	}/* end default constructor ClientReportingFrame() */
	
	public void openHelp() {
	    this.parent.defineAction(this.JButton4.getActionCommand());    
	}
	
	public void parentApplicationClosing() {
	    try {
	        if (this.isReportActive()) {
	    	    int reply = JOptionPane.showConfirmDialog(this, 
                    "Do you want to save your active report?", 
                    "Save Active Report?" , 
                    JOptionPane.YES_NO_OPTION, 
                    JOptionPane.QUESTION_MESSAGE);
                   
                if (reply == JOptionPane.YES_OPTION) {
                    this.saveFile();
                }
	    	}
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
    public boolean getSupportsSave() {
        return true;    
    }
	
	public void store() {
	    this.parent.displayErrorDialog("There is no data to store in the database");    
	}
	
	public void saveLocally() {
	    this.saveFile();   
	}
	
	private void buildITSAFMap() {
	    try {
	        this.itsaf_map.put(new Integer(1), "Policy");
	        this.itsaf_map.put(new Integer(2), "Procedures");
	        this.itsaf_map.put(new Integer(3), "Implemented");
	        this.itsaf_map.put(new Integer(4), "Tested");
	        this.itsaf_map.put(new Integer(5), "Integrated");
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
	private void buildReportMap() {
	    try {
            this.report_map.put("Summary of topic areas by levels of effectiveness", "get_policy_results_and_text");
	        this.report_map.put("List of non-applicable questions", "get_na_questions");
	        this.report_map.put("List of risk based decisions", "get_rbdm_questions");
	        this.report_map.put("System Summary", "get_summary_question_results");  	        
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	  
    private void setReportHeadersToSystemSummary() {
        try {
            this.table_headers = new Vector();
            this.table_headers.addElement("Question #");
            this.table_headers.addElement("Question Text");
            this.table_headers.addElement("Level Reached");
            this.table_headers.addElement("N/A");
            this.table_headers.addElement("Risk Based Decision?");
            this.table_headers.addElement("Comments");
            this.table_headers.addElement("Answered By");
            this.table_headers.addElement("Completed?");
            this.table_headers.addElement("Refer To");
        }catch (Exception e) {
            e.printStackTrace();
        }        
    }	    
    
    private void setReportHeadersToTopicAreaSummary() {
        try {
            this.table_headers = new Vector();
            this.table_headers.addElement("Topic #");
            this.table_headers.addElement("Topic Area");
            this.table_headers.addElement("Level");                        
        }catch (Exception e) {
            e.printStackTrace();
        }        
    }
    	    
    private void setReportHeadersToNAQuestionsSummary() {
        try {
            this.table_headers = new Vector();
            this.table_headers.addElement("Question #");
            this.table_headers.addElement("Question Text");
            this.table_headers.addElement("Comments");                        
        }catch (Exception e) {
            e.printStackTrace();
        }        
    }
    
    private void setReportHeadersToRiskBasedQuestionsSummary() {
        try {
            this.table_headers = new Vector();
            this.table_headers.addElement("Question Number");
            this.table_headers.addElement("Question Text");
            this.table_headers.addElement("Comments");
        }catch (Exception e) {
            e.printStackTrace();
        }        
    }  
    

	private void clearResultsTable() {
        try {
            this.report_model.setDataVector(new Vector(), new Vector());
            this.report_table.setModel(this.report_model);
        }catch (Exception e) {
            e.printStackTrace();
        }
	}
		
	public void setPrimaryAssessor(String assessor_name) {
	    try {
	        this.primary_assessor.setText(assessor_name);    
	    }catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	
	// This method is designed to encapsulate changing the cursor type
	// it is used to show the user that an action is occurring that needs 
	// to pause for.
	private void internal_setCursor(String cursor_type) {
	    try {
	        if (cursor_type.equals("wait")) {
                this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.WAIT_CURSOR));
	        }else  if (cursor_type.equals("default")) {
	            this.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
	        }
	    }catch (Exception e) {
	        this.parent.log(e.toString());
	    }
	}
		
    public void buildSummaryReport(String report_type) {
        CallableStatement query = null;
        ResultSet query_result = null;
        Connection conn = this.parent.connectionGenerator();
        Vector table_row = new Vector();
        SortButtonRenderer renderer = new SortButtonRenderer();
        StringBuffer number = new StringBuffer("");                
        String text = "";  
        try {
            this.prgMonitor.clear();
            this.prgMonitor.setProgressMax(100);
            this.prgMonitor.setVisible(true);
            this.internal_setCursor("wait");
            this.toggleOperationMode();
            this.clearResultsTable();
            this.parent.setStatusMsg("Building report now, please hold");
            
            query = conn.prepareCall("{call get_primary_assessor(?)}");
            query.setString(1, this.getActiveAssessment());
            query_result = query.executeQuery();
            query_result.next();
            this.setPrimaryAssessor(query_result.getString("full_name"));
            conn.close();
            
            conn = this.parent.connectionGenerator();
            query = conn.prepareCall("{call get_all_component_information(?, ?)}");
            query.setString(1, this.system_number_field.getText());
            query.setString(2, this.getActiveAssessment());
            query_result = query.executeQuery();
            query_result.next();
            this.location_field.setText(query_result.getString("location"));
            this.confidentiality_field.setText(query_result.getString("confidentiality"));
            this.integrity_field.setText(query_result.getString("integrity"));
            this.availability_field.setText(query_result.getString("availability"));
            conn.close();
            
            this.system_name.setText(this.system_name_label.getText());
            this.system_number.setText(this.system_number_field.getText());
            
            conn = this.parent.connectionGenerator();
            query = conn.prepareCall("{call " + (String) this.report_map.get(report_type) + "(?)}");                        
            this.report_generated_date.setText(new java.util.Date().toString());              
            
            this.setReportActive(true);
            
            if (report_type.equals("Summary of topic areas by levels of effectiveness")) {
                this.prgMonitor.setStatusBusyMessage("Building summary of topics areas report now, please hold");
                CallableStatement subr_ques = null;
                ResultSet subordinate_ques_results = null;
                
                this.report_name.setText("Summary of topic areas by level of effectiveness");   
                query.setString(1, this.getActiveAssessment());
                this.setReportHeadersToTopicAreaSummary();
                this.report_model.setColumnIdentifiers(this.table_headers);
                this.report_table.setModel(this.report_model);
                                
                this.prgMonitor.setNormalizedProgress(20);
                query_result = query.executeQuery();
                this.prgMonitor.setNormalizedProgress(50);                  
                
                int major = 0;
                int minor = 0;
                int num = 0;
                int policy_level1 = 0;
                while (query_result.next()) {
                    Connection conn2 = this.parent.connectionGenerator();
                    table_row = new Vector();
                    number = new StringBuffer("");    
                    text = query_result.getString("question_text");
                    major = query_result.getInt("major_section");
                    minor = query_result.getInt("minor_section");
                    num = query_result.getInt("question_number");
                    number.append(major + "." + minor + "." + num);
                    table_row.addElement(number.toString());                                        
                    table_row.addElement(text);
                    policy_level1 = query_result.getInt("level1");
                    if (policy_level1 != 0) {
                        subr_ques = conn2.prepareCall("{call get_question_results_per_policy(?, ?)}");
                        subr_ques.setString(1, this.getActiveAssessment());
                        subr_ques.setInt(2, major);
                        subordinate_ques_results = subr_ques.executeQuery();
                    
                        int level1_total = 0;
                        int level2_total = 0;
                        int level3_total = 0;
                        int level4_total = 0;
                        int level5_total = 0;
                        int na = 0;
                        int question_count = 0;
                        while (subordinate_ques_results.next()) {
                            level1_total += subordinate_ques_results.getInt("level1");
                            level2_total += subordinate_ques_results.getInt("level2");
                            level3_total += subordinate_ques_results.getInt("level3");
                            level4_total += subordinate_ques_results.getInt("level4");
                            level5_total += subordinate_ques_results.getInt("level5");
                            na += subordinate_ques_results.getInt("na");
                            question_count++;
                        }
                        if (question_count != na) {
                            question_count = question_count - na;
                        }else {
                            question_count = 1;    
                        }                       
                    
                        if (level1_total >= question_count) {
                            if (level2_total >= question_count) {
                                if (level3_total >= question_count) {
                                    if (level4_total >= question_count) {
                                        if (level5_total >= question_count) {
                                            table_row.addElement((String) this.itsaf_map.get(new Integer(5)));   
                                        }else {
                                            table_row.addElement((String) this.itsaf_map.get(new Integer(4)));    
                                        }
                                    }else {
                                         table_row.addElement((String) this.itsaf_map.get(new Integer(3)));
                                    }
                                }else {
                                    table_row.addElement((String) this.itsaf_map.get(new Integer(2)));
                                }
                            }else {
                                table_row.addElement((String) this.itsaf_map.get(new Integer(1)));
                            }
                        }else {
                            if (question_count > 1) {
                                table_row.addElement("None");    
                            }else {
                                table_row.addElement((String) this.itsaf_map.get(new Integer(1)));
                            }
                        }                                        

                        this.report_model.addRow(table_row);
                        conn2.close();
                    }else {
                        table_row.addElement("None"); 
                        this.report_model.addRow(table_row);
                    }
                }
            }
            
            if (report_type.equals("System Summary")) {
                conn = this.parent.connectionGenerator();
                query = conn.prepareCall("{call " + (String) this.report_map.get(report_type) + "(?)}"); 
                query.setString(1, this.getActiveAssessment());

                this.report_name.setText("System Summary");    
                this.prgMonitor.setStatusBusyMessage("Build system summary report now, please hold");                
                this.setReportHeadersToSystemSummary();
                this.report_model.setColumnIdentifiers(this.table_headers);
                this.report_table.setModel(this.report_model);
                
                this.prgMonitor.setNormalizedProgress(20);
                query_result = query.executeQuery();
                this.prgMonitor.setNormalizedProgress(50);  
                String full_name = "";
                String txt = "";
                String cmnts = "";
                int level1 = 0;
                int level2 = 0;
                int level3 = 0;
                int level4 = 0;
                int level5 = 0;
                int na = 0;
                int rbdm = 0;
                int ar = 0;
                String reviewer = "N/A";
                int completed = 0;                
                while (query_result.next()) {
                    full_name = "";
                    number = new StringBuffer("");
                    table_row = new Vector();
                    txt = query_result.getString("question_text");
                    number.append(query_result.getInt("major_section") + "." + query_result.getInt("minor_section") + "." + query_result.getInt("question_number"));
                    table_row.addElement(number.toString());
                    table_row.addElement(txt.trim());
                    level1 = query_result.getInt("level1");
                    level2 = query_result.getInt("level2");
                    level3 = query_result.getInt("level3");
                    level4 = query_result.getInt("level4");
                    level5 = query_result.getInt("level5");
                    rbdm = query_result.getInt("rbdm");
                    cmnts = (query_result.getString("cmnts")).trim();
                    ar = query_result.getInt("ar");
                    na = query_result.getInt("na");
                    if (ar == 1) {
                        reviewer = (query_result.getString("reviewer")).trim();
                    }else {
                        reviewer = "N/A";    
                    }
                    completed = query_result.getInt("completed");
                    full_name = (query_result.getString("full_name")).trim();
                    if (level1 != 0 && na == 0) {
                        if (level2 != 0) {
                            if (level3 != 0) {
                                if (level4 != 0) {
                                    if (level5 != 0) {
                                        table_row.addElement((String) this.itsaf_map.get(new Integer(5)));
                                    }else {
                                        table_row.addElement((String) this.itsaf_map.get(new Integer(4)));    
                                    }
                                }else {
                                    table_row.addElement((String) this.itsaf_map.get(new Integer(3)));    
                                }
                            }else {
                                table_row.addElement((String) this.itsaf_map.get(new Integer(2)));       
                            }
                        }else {
                            table_row.addElement((String) this.itsaf_map.get(new Integer(1)));   
                        }
                    }else {
                        table_row.addElement("None");    
                    }
                    if (na == 1) {
                        table_row.addElement("Yes");
                    }else {
                        table_row.addElement("No");    
                    }
                    if (rbdm == 1) {
                        table_row.addElement("Yes");
                    }else {
                        table_row.addElement("No");
                    }
                    table_row.addElement(cmnts);
                    table_row.addElement(full_name);
                    if (completed == 1) {
                        table_row.addElement("Yes");
                    }else {
                        table_row.addElement("No");
                    }
                    table_row.addElement(reviewer);
                    this.report_model.addRow(table_row);
                }
                
            }
            if (report_type.equals("List of non-applicable questions")) {
                conn = this.parent.connectionGenerator();
                query = conn.prepareCall("{call " + (String) this.report_map.get(report_type) + "(?)}"); 
                query.setString(1, this.getActiveAssessment());
                
                this.report_name.setText("List of non-applicable questions");                              
                this.prgMonitor.setStatusBusyMessage("Build summary report of non-applicable questions now, please hold");
                this.setReportHeadersToNAQuestionsSummary();
                this.report_model.setColumnIdentifiers(this.table_headers);
                this.report_table.setModel(this.report_model);
               
                this.prgMonitor.setNormalizedProgress(20);
                query_result = query.executeQuery();
                this.prgMonitor.setNormalizedProgress(50);
                int component_num = 0;
                String loc = "";
              
                while (query_result.next()) {
                    number = new StringBuffer("");
                    table_row = new Vector();
                    text = query_result.getString("question_text").trim();
                    number.append(query_result.getInt("major_section") + "." + query_result.getInt("minor_section") + "." + query_result.getInt("question_number"));
                    table_row.addElement(number.toString());
                    table_row.addElement(text);
                    table_row.addElement(query_result.getString("cmnts"));
                    this.report_model.addRow(table_row);
                }
                this.prgMonitor.setNormalizedProgress(70);                
            }
            
            if (report_type.equals("List of risk based decisions")) {                
                conn = this.parent.connectionGenerator();
                query = conn.prepareCall("{call " + (String) this.report_map.get(report_type) + "(?)}"); 
                query.setString(1, this.getActiveAssessment());                
                
                this.prgMonitor.setStatusBusyMessage("Build summary report of all risk based decisions now, please hold");
                this.report_name.setText("Summary of risk based decisions");
                this.setReportHeadersToRiskBasedQuestionsSummary();
                this.report_model.setColumnIdentifiers(this.table_headers);
                this.report_table.setModel(this.report_model);
                
                this.prgMonitor.setNormalizedProgress(20);
                query_result = query.executeQuery(); 
                String component_name = "";
                String assessment_id = "";
                String start_date = "";              
                while (query_result.next()) {
                    number = new StringBuffer("");
                    table_row = new Vector();
                    text = query_result.getString("question_text").trim();
                    number.append(query_result.getInt("major_section") + "." + query_result.getInt("minor_section") + "." + query_result.getInt("question_number"));
                    table_row.addElement(number.toString());
                    table_row.addElement(text);
                    table_row.addElement(query_result.getString("cmnts"));
                    this.report_model.addRow(table_row);
                }
            }
            
            conn.close();
            this.internal_setCursor("default");
            this.parent.setStatusMsg("");
            this.totals_label.setText((this.report_model.getDataVector().size()) + " records returned");
            this.report_table.setModel(this.report_model);
            this.prgMonitor.setNormalizedProgress(90);
            this.JTabbedPane1.setSelectedIndex(1);
            this.prgMonitor.setNormalizedProgress(100);
            this.prgMonitor.setVisible(false);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void forceRepaint() {
        Graphics g = this.getGraphics();
        this.update(g);
    }

    public void renderReport(String html) {
        try {
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static ClientReportingFrame spawnReportingWindow(ASSET parent) {
        parent.setStatusModeMsg(" RPRT ");
        return new ClientReportingFrame(parent);        
    }

	public ClientReportingFrame(String sTitle) {
		this();
		setTitle(sTitle);
	}
	
	public ClientReportingFrame(ASSET parent) {
    	this();
	    try {		   
		    this.parent = parent;
		    this.setVisible(true);
		}catch (Exception e) {
		    e.printStackTrace();
		}
	}	
	
	public void addNotify() {
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets and menu bar
		Insets insets = getInsets();
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
			menuBarHeight = menuBar.getPreferredSize().height;
		int offset = 0;
		Component comp[] = getComponents();
		for(int i = 0; i < comp.length; ++i) {
			if (comp[i] instanceof javax.swing.JRootPane)
				continue;
			offset += comp[i].getPreferredSize().height;
		}
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight + offset);
	}

    class HeaderListener extends MouseAdapter {
        JTableHeader   header;    
        SortButtonRenderer renderer;      
    
        HeaderListener(JTableHeader header,SortButtonRenderer renderer) {      
            this.header   = header;      
            this.renderer = renderer;
        }
    
        public void mousePressed(MouseEvent e) {
            int col = header.columnAtPoint(e.getPoint());
            int sortCol = header.getTable().convertColumnIndexToModel(col);
            renderer.setPressedColumn(col);
            renderer.setSelectedColumn(col);
            header.repaint();
            if (header.getTable().isEditing()) {
                header.getTable().getCellEditor().stopCellEditing();
            }            
            boolean isAscent;      
            if (SortButtonRenderer.DOWN == renderer.getState(col)) {        
                isAscent = true;      
            }else {
                isAscent = false;
            }
            ((SortableTableModel)header.getTable().getModel()).sortByColumn(sortCol, isAscent);        
        } 
     
        public void mouseReleased(MouseEvent e) {      
    
            int col = header.columnAtPoint(e.getPoint());      
            renderer.setPressedColumn(-1);
                // clear      
            header.repaint();    
        }  
    }/* end internal class HeaderListener() */

	class SymMouse extends java.awt.event.MouseAdapter {
		public void mouseExited(java.awt.event.MouseEvent event) {
			Object object = event.getSource();
		    if (object == na_summary)
		        na_summary.rollover_exit();	
		    if (object == assessment_summary)
		        assessment_summary.rollover_exit();			        
		    if (object == topic_summary)
		        topic_summary.rollover_exit();	
		    if (object == system_summary)
		        system_summary.rollover_exit();			        		        
		}

		public void mouseEntered(java.awt.event.MouseEvent event) {
			Object object = event.getSource();
			if (object == na_summary)
		        na_summary.rollover_enter();
		    if (object == assessment_summary)
		        assessment_summary.rollover_enter();			        
		    if (object == topic_summary)
		        topic_summary.rollover_enter();
		    if (object == system_summary)
		        system_summary.rollover_enter();			        		        		        
		}
		
		public void mouseClicked(java.awt.event.MouseEvent event) {
		    Object object = event.getSource();
			if (object == na_summary) {
			    if (getActiveAssessment().length() > 1) {
			        buildSummaryReport(na_summary.getPlainText());
			    }else {
			        displayErrorDialog("You must select an active assessment first!");
			    }
			}
			if (object == assessment_summary) {
			    if (getActiveAssessment().length() > 1) {
			        buildSummaryReport(assessment_summary.getPlainText());
			    }else {
			        displayErrorDialog("You must select an active assessment first!");
			    }
			}
			if (object == topic_summary) {
			    if (getActiveAssessment().length() > 1) {
			        buildSummaryReport(topic_summary.getPlainText());
			    }else {
			        displayErrorDialog("You must select an active assessment first!");
			    }
			}
			if (object == system_summary) {
			    if (getActiveAssessment().length() > 1) {
			        buildSummaryReport(system_summary.getPlainText());
			    }else {
                    displayErrorDialog("You must select an active assessment first!");
                }
            }
			if (object == ClientReportingFrame.this)
				ClientReportingFrame_mouseClicked(event);						
		}
	}/* end internal class SymMouse() */	

    public String getActiveAssessment() {
        return this.active_assessment;    
    }
    
    // This method will export the results of the selected table (either 
    // assessment or system summary tab) to a csv file that can be imported 
    // into your basic office applications such as Excell or Access
    // References:
    // 1. http://www.esus.com/javaindex/j2se/jdk1.2/javaxswing/
    //    editableatomiccontrols/jfilechooser/jfilechoosersave.html
    String ReplaceParagraphMarks ( String in )
    {
        String out = "";
        int i;
        
        for ( i = 0 ; i < in.length() ; i ++ )
          {
          	if ( in.charAt(i) != '\n' && in.charAt(i) != '\r' && in.charAt(i) != '\t'  )
        	  out += in.charAt(i);    	
        	else
        	  out += " <> ";
          }
        	
        return out;
    	
    	
    }
    
    void saveFile() {
        File save_target = null;
        try {
            fileSaver.setDialogTitle("Save Summary Results File");            
            int choice = fileSaver.showSaveDialog(this);
            if (choice == fileSaver.APPROVE_OPTION) {
                 save_target = fileSaver.getSelectedFile();
                 PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(save_target)));
                 DefaultTableModel test_model = (DefaultTableModel) this.report_table.getModel();
                 Vector temp_row = null;
                 StringBuffer output = new StringBuffer("");
                 out.println("Report Name\t" + this.report_name.getText() + "\tConfidentiality\t" + this.confidentiality_field.getText() );
                 out.println("System Name\t" + this.system_name.getText() + "\tIntegrity\t" + this.integrity_field.getText());                 
                 out.println("System Number\t" + this.system_number.getText() + "\tAvailability\t" + this.availability_field.getText());
                 out.println("Primary Assessor\t" + this.primary_assessor.getText() + "\tLocation\t" + this.location_field.getText());
                 out.println("Today's Date\t " + this.report_generated_date.getText() + "\tTotals\t" + this.totals_label.getText());
                 out.println("");
                 String nl = System.getProperty("line.separator");
                 for (int n = 0; n < this.table_headers.size(); n++) {
                     output.append((String) this.table_headers.elementAt(n));
                     if (n < this.table_headers.size() - 1) {
                        output.append("\t");
                     }                        
                 }                     
                 output.append(nl);
                 out.println(output.toString());
                 for (int i = 0; i < (test_model.getDataVector()).size(); i++) {
                     temp_row = (Vector) (test_model.getDataVector()).elementAt(i);
                     output = new StringBuffer("");
                     for (int j = 0; j < temp_row.size(); j++) {
                         output.append(ReplaceParagraphMarks((String) temp_row.elementAt(j)));
                         if (j < temp_row.size() - 1) {
                            output.append("\t");
                         }                            
                     }
                     output.append(nl);
                     out.println(output.toString());
                 }
                 out.close();
                 this.displayStatusDialog("Results exported successfully!");
            }else {
            }
        }catch (Exception e) {
            e.printStackTrace();
        }
    }/* end method saveFile() */
    
    public void setReportActive(boolean flag) {
        this.report_active = flag;        
    }
    
    public boolean isReportActive() {
        return this.report_active;
    }
    
	private void displayStatusDialog(String msg) {
        try {
            JOptionPane.showMessageDialog(this, msg, "System Message:", JOptionPane.INFORMATION_MESSAGE);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }    

	private void displayErrorDialog(String msg) {
        try {
            JOptionPane.showMessageDialog(this, msg, "Error:", JOptionPane.ERROR_MESSAGE);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }    
    
    public void setActiveAssessment(String new_active) {
        this.active_assessment = new_active;
        try {
            this.system_id_label.setText(this.active_assessment);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void setActiveName(String name) {
        this.system_name_label.setText(name);
    }
    
    public void setActiveNumber(String name) {
        this.system_number_field.setText(name);
    }
    
    public void setActiveDate(String date) {
        this.system_date_label.setText(date);    
    }

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	com.symantec.itools.javax.swing.icons.ImageIcon reportIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel16 = new javax.swing.JPanel();
	javax.swing.JToolBar JToolBar1 = new javax.swing.JToolBar();
	javax.swing.JButton JButton2 = new javax.swing.JButton();
	javax.swing.JButton JButton3 = new javax.swing.JButton();
	javax.swing.JButton JButton4 = new javax.swing.JButton();
	javax.swing.JTabbedPane JTabbedPane1 = new javax.swing.JTabbedPane();
	javax.swing.JPanel JPanel14 = new javax.swing.JPanel();
	com.symantec.itools.javax.swing.JSplitPaneWrapper JSplitPaneWrapper1 = new com.symantec.itools.javax.swing.JSplitPaneWrapper();
	javax.swing.JPanel JPanel17 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel10 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel11 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JLabel system_name_label = new javax.swing.JLabel();
	javax.swing.JPanel JPanel25 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel14 = new javax.swing.JLabel();
	javax.swing.JLabel system_number_field = new javax.swing.JLabel();
	javax.swing.JPanel JPanel12 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JLabel system_date_label = new javax.swing.JLabel();
	javax.swing.JPanel JPanel18 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	com.symantec.itools.javax.swing.JWrappingLabel system_id_label = new com.symantec.itools.javax.swing.JWrappingLabel();
	javax.swing.JPanel JPanel19 = new javax.swing.JPanel();
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	javax.swing.JPanel JPanel33 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel35 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel34 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel4 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel9 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel8 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel6 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel13 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel7 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel5 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel15 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel20 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel21 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JLabel report_name = new javax.swing.JLabel();
	javax.swing.JPanel JPanel28 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel16 = new javax.swing.JLabel();
	javax.swing.JLabel confidentiality_field = new javax.swing.JLabel();
	javax.swing.JPanel JPanel26 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel17 = new javax.swing.JLabel();
	javax.swing.JLabel system_name = new javax.swing.JLabel();
	javax.swing.JPanel JPanel29 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel19 = new javax.swing.JLabel();
	javax.swing.JLabel integrity_field = new javax.swing.JLabel();
	javax.swing.JPanel JPanel27 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel18 = new javax.swing.JLabel();
	javax.swing.JLabel system_number = new javax.swing.JLabel();
	javax.swing.JPanel JPanel30 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel20 = new javax.swing.JLabel();
	javax.swing.JLabel availability_field = new javax.swing.JLabel();
	javax.swing.JPanel JPanel24 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel15 = new javax.swing.JLabel();
	javax.swing.JLabel primary_assessor = new javax.swing.JLabel();
	javax.swing.JPanel JPanel31 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel21 = new javax.swing.JLabel();
	javax.swing.JLabel location_field = new javax.swing.JLabel();
	javax.swing.JPanel JPanel22 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel13 = new javax.swing.JLabel();
	javax.swing.JLabel report_generated_date = new javax.swing.JLabel();
	javax.swing.JPanel JPanel23 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JLabel totals_label = new javax.swing.JLabel();
	javax.swing.JPanel JPanel32 = new javax.swing.JPanel();
	javax.swing.JScrollPane JScrollPane2 = new javax.swing.JScrollPane();
	javax.swing.JTable report_table = new javax.swing.JTable();
	com.symantec.itools.javax.swing.borders.EmptyBorder report_title_label_border = new com.symantec.itools.javax.swing.borders.EmptyBorder();
	com.symantec.itools.javax.swing.borders.EmptyBorder report_pane_border = new com.symantec.itools.javax.swing.borders.EmptyBorder();
	com.symantec.itools.javax.swing.icons.ImageIcon saveIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.borders.EmptyBorder report_header_border = new com.symantec.itools.javax.swing.borders.EmptyBorder();
	com.symantec.itools.javax.swing.icons.ImageIcon helpIcon = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon imageIcon1 = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.borders.EtchedBorder etchedBorder1 = new com.symantec.itools.javax.swing.borders.EtchedBorder();
	com.symantec.itools.javax.swing.models.StringComboBoxModel graphic_report_style = new com.symantec.itools.javax.swing.models.StringComboBoxModel();
	com.symantec.itools.javax.swing.models.StringTableModel chart_data_model = new com.symantec.itools.javax.swing.models.StringTableModel();
	com.symantec.itools.javax.swing.icons.ImageIcon imageIcon2 = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.borders.EmptyBorder emptyBorder1 = new com.symantec.itools.javax.swing.borders.EmptyBorder();
	//}}
	boolean report_active = false;
	Hashtable itsaf_map = new Hashtable();
	boolean operation_mode = false;
	JFileChooser fileSaver = new JFileChooser();
	String active_assessment = "";
	SymAction lSymAction = new SymAction();
	ProgressDialog prgMonitor = null;
	SortableTableModel report_model = new SortableTableModel() {
	    public boolean isCellEditable(int row, int column) {
            return false;
        }	    	    
	};
	Vector table_headers = new Vector();
	SymMouse aSymMouse = new SymMouse();
    JFileChooser savedDialog = new JFileChooser();
    HTMLLabel component_summary = null;
    HTMLLabel area_summary = null;
    HTMLLabel na_summary = null;
    HTMLLabel primary_summary = null;
    HTMLLabel assessment_summary = null;
    HTMLLabel type_summary = null;
    HTMLLabel sensitivity_summary = null;
    HTMLLabel topic_summary = null;
    HTMLLabel accountability_summary = null;
    HTMLLabel system_summary = null;
    ASSET parent = null;
    ClientAssessmentChooser chooser = null;
    Hashtable report_map = new Hashtable();
	
	public void toggleOperationMode() {
	    this.operation_mode = true;    
	}
	
	public boolean getOperationMode() {
	    return this.operation_mode;    
	}
	
	public void finalize() throws Throwable {
		//{{CLEANUP
		//}}		
		super.finalize();
	}

    public void showAssessmentChooserDialog() {
        try {
            if (chooser == null) {
                chooser = ClientAssessmentChooser.spawnNewClientAssessmentChooser(this);                
            }
            chooser.setVisible(true);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

	class SymAction implements java.awt.event.ActionListener {
	    
		public void actionPerformed(java.awt.event.ActionEvent event) {
			Object object = event.getSource();
			if (object == JButton3)
				JButton3_actionPerformed(event);
			else if (object == JButton2)
				JButton2_actionPerformed(event);
			else if (object == JButton1)
				JButton1_actionPerformed(event);
			else if (object == JButton4)
				JButton4_actionPerformed(event);
		}
	}/* end internal class SymAction() */

	class SymInternalFrame implements javax.swing.event.InternalFrameListener {
	    
		public void internalFrameOpened(javax.swing.event.InternalFrameEvent event) {
		}

		public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent event) {
			Object object = event.getSource();
			if (object == ClientReportingFrame.this)
				ClientReportingFrame_internalFrameDeiconified(event);
		}

		public void internalFrameIconified(javax.swing.event.InternalFrameEvent event)
		{
			Object object = event.getSource();
			if (object == ClientReportingFrame.this)
				ClientReportingFrame_internalFrameIconified(event);
		}

		public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent event)
		{
		}

		public void internalFrameClosed(javax.swing.event.InternalFrameEvent event)
		{
		}

		public void internalFrameClosing(javax.swing.event.InternalFrameEvent event)
		{
		    parentApplicationClosing();
		    parent.setStatusModeMsg("Idle...");
		}

		public void internalFrameActivated(javax.swing.event.InternalFrameEvent event) {
		
		}
	}

	void ClientReportingFrame_internalFrameIconified(javax.swing.event.InternalFrameEvent event)
	{
		// to do: code goes here.
		this.parent.setStatusModeMsg("Idle...");
	}

	void ClientReportingFrame_internalFrameDeiconified(javax.swing.event.InternalFrameEvent event)
	{
		// to do: code goes here.
		this.parent.setStatusModeMsg(" RPT ");
	}

	void JButton3_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton3_actionPerformed_Interaction1(event);
	}

	void JButton3_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.showAssessmentChooserDialog();
		} catch (java.lang.Exception e) {
		}
	}

	void JButton2_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton2_actionPerformed_Interaction1(event);
	}

	void JButton2_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
		    if (this.getOperationMode()) {
			    this.saveFile();
			}else {
			    this.displayErrorDialog("You must generate report results before you can export anything to a flat file!");    
			}
		} catch (java.lang.Exception e) {
		}
	}

	void JButton1_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton1_actionPerformed_Interaction1(event);
	}

	void JButton1_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.showAssessmentChooserDialog();
		} catch (java.lang.Exception e) {
		}
	}

	void JButton4_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton4_actionPerformed_Interaction1(event);
	}

	void JButton4_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.openHelp();
		} catch (java.lang.Exception e) {
		}
	}

	void ClientReportingFrame_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		ClientReportingFrame_mouseClicked_Interaction1(event);
	}

	void ClientReportingFrame_mouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
		try {
			this.forceRepaint();
		} catch (java.lang.Exception e) {
		}
	}
}/* end class ClientReportingFrame() */