/****************************************************************************************/
/* file - SplashScreen.java                                                             */
/* ------------------------                                                             */
/* This file is the container class for the Splash Screen for System. It extends the    */
/* JWindow class because the JWindow class does not have any menu bar or title bar that */
/* normal windows do, this makes it the perfect container for the Splash image.         */
/* ------------------------                                                             */
/* Author - Mark McLarnon                                                               */
/****************************************************************************************/
import java.awt.*;
import javax.swing.*;
import com.symantec.itools.javax.swing.icons.ImageIcon;
import com.symantec.itools.javax.swing.borders.EtchedBorder;

public class SplashScreen extends javax.swing.JWindow {
    
	public SplashScreen(Frame parent) {
		super(parent);
		
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		getContentPane().setLayout(new BoxLayout(this.getContentPane(),BoxLayout.X_AXIS));
		setSize(500,300);
		setVisible(false);
		try {
			imageIcon1.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/SplashScreen.jpg"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ imageIcon1.move(0,306);
		//$$ etchedBorder1.move(24,306);
		JPanel1.setAlignmentY(0.497778F);
		JPanel1.setBorder(etchedBorder1);
		JPanel1.setLayout(new BoxLayout(JPanel1,BoxLayout.X_AXIS));
		getContentPane().add(JPanel1);
		l.setDoubleBuffered(true);
		JPanel1.add(l);
		l.setIcon(imageIcon1);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		l.addMouseListener(aSymMouse);
		//}}
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension labelSize = l.getPreferredSize();
        setLocation(screenSize.width/2 - (labelSize.width/2),
                    screenSize.height/2 - (labelSize.height/2));
	}

	public SplashScreen()
	{
		this((Frame)null);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	com.symantec.itools.javax.swing.icons.ImageIcon imageIcon1 = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.borders.EtchedBorder etchedBorder1 = new com.symantec.itools.javax.swing.borders.EtchedBorder();
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JLabel l = new javax.swing.JLabel();
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == SplashScreen.this)
				SplashScreen_WindowClosing(event);
		}
	}

	void SplashScreen_WindowClosing(java.awt.event.WindowEvent event)
	{
		// Hide the Frame
		setVisible(false);
		
		// Free the system resources
		dispose();
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == l)
				l_mouseClicked(event);
		}
	}

	void l_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		l_mouseClicked_Interaction1(event);
	}

	void l_mouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
		try {
			this.dispose();
		} catch (java.lang.Exception e) {
		}
	}
}/* end class SplashScreen() */