/************************************************************************************/
/* file - SystemtoAssess.java                                                       */
/* --------------------------                                                       */
/* This class represents the encapsulation of the necessary system information.     */
/* --------------------------                                                       */
/* NIST Self-Assessment System                                                      */
/* Author - Mark McLarnon                                                           */
/* --------------------------                                                       */
/* Change Control:                                                                  */
/* 03/26/02 - Had to change the system number to a String, this required four change*/
/*            s to the SystemtoAssess class.                                        */
/************************************************************************************/
import java.io.Serializable;

public class SystemtoAssess implements Serializable {
    
    public SystemtoAssess () {
        
    }
    
    public static SystemtoAssess createNewSystem() {
        return new SystemtoAssess();    
    }
    
    public SystemtoAssess (String num, String agd, String name, String type) {
        this.setSystemNumber(num);
        this.setAgencyGroupDivision(agd);
        this.setSystemName(name);
        this.setSystemType(type);
    }
    
    public static SystemtoAssess createNewSystem(String num, String agd, String name, String type) {
        return new SystemtoAssess(num, agd, name, type);    
    }
    
    public void setSystemNumber(String num) {
        this.system_number = num;    
    }
    
    public String getSystemNumber() {
        return this.system_number;        
    }
    
    public void setAgencyGroupDivision(String value) {
        this.aggrpdiv = value;
    }
    
    public String getAgencyGroupDivision() {
        return this.aggrpdiv;    
    }
    
    public void setSystemName(String name) {
        this.system_name = name;    
    }
    
    public String getSystemName() {
        return this.system_name;    
    }
    
    public void setSystemType(String type) {
        this.system_type = type;
    }
    
    public String getSystemType() {
        return this.system_type;    
    }
    
    protected String system_number = "";
    protected String aggrpdiv = "";
    protected String system_name = "";
    protected String system_type = "";
}/* end class SystemtoAssess() */