create procedure insert_assessment_question_response
(
@assessment_id    varchar(100),
@major_section    integer,
@minor_section    integer,
@question_number  integer,
@version          integer,
@level1           integer,
@level2           integer,
@level3           integer,
@level4           integer,
@level5           integer,
@rbdm             integer,
@cmnts            text,
@ar               integer,
@na               integer,
@reviewer         varchar(50),
@completed        integer
)
AS
IF (NOT EXISTS (SELECT * FROM assessment_question_responses WHERE assessment_id = @assessment_id AND major_section = @major_section AND minor_section = @minor_section AND question_number = @question_number))
BEGIN
    INSERT INTO assessment_question_responses
    (
	[assessment_id],
	[major_section], 
	[minor_section], 
	[question_number], 
	[version], 
	[level1], 
	[level2], 
	[level3], 
	[level4], 
	[level5], 
	[rbdm], 
	[cmnts], 
	[ar],
        [na], 
	[reviewer],
        [completed]
    )
    VALUES 
    (
	@assessment_id, 
	@major_section, 
	@minor_section, 
	@question_number, 
	@version, 
	@level1, 
	@level2, 
	@level3, 
	@level4, 	
	@level5, 
	@rbdm, 
	@cmnts, 
	@ar, 
        @na,
	@reviewer,
	@completed
    )
END
ELSE
    UPDATE assessment_question_responses 
    SET level1 = @level1,
        level2 = @level2,
	level3 = @level3,
	level4 = @level4,
	level5 = @level5,
        rbdm = @rbdm,
        cmnts = @cmnts,
        ar = @ar,
        na = @na,
        reviewer = @reviewer,
	completed= @completed
    WHERE assessment_id  = @assessment_id
    AND   major_section  = @major_section
    AND   minor_section  = @minor_section
    AND   question_number= @question_number
GO

