create procedure save_assessment
(
@assessment_id      varchar(100),
@start_timestamp    varchar(40),
@completed          integer, 
@bookmark           varchar(15),
@primary_assessor   varchar(50),
@progress           integer
)

AS

IF (NOT EXISTS (SELECT * from assessments WHERE assessment_id = @assessment_id)) 
BEGIN
    INSERT INTO assessments
    (
	[assessment_id], 
	[start_timestamp], 
	[completed], 
	[bookmark], 
	[primary_assessor],
        [progress]
    )
    VALUES 
    (
	@assessment_id, 
	@start_timestamp, 
	@completed, 
	@bookmark, 
	@primary_assessor,
        @progress
    )
END
ELSE
    UPDATE assessments
    SET completed        = @completed,
     	bookmark         = @bookmark,
	progress         = @progress
    WHERE assessment_id  = @assessment_id
GO