/*
Updated Stored Procedure 1.04 
*/
create procedure save_component
(
@component_num         varchar(100),
@assessment_id         varchar(100),
@location              varchar(100),
@component_name        varchar(50),
@component_type        varchar(50),
@assessment_obj        varchar(255)
)
AS
IF (NOT EXISTS (SELECT * from components WHERE assessment_id = @assessment_id AND
							  component_name = @component_name ))
BEGIN
    INSERT INTO components
    (
        [component_num], 
        [assessment_id], 
        [location], 
        [component_name], 
        [component_type], 
        [assessment_obj]
    )
    VALUES 
    (
	@component_num, 
	@assessment_id, 
	@location, 
	@component_name, 
	@component_type, 
	@assessment_obj
    )
END
ELSE
	BEGIN

	/* Update Main Table */	
	declare @oldCompNum   varchar(100)

	set @oldCompNum = ( select component_num from components WHERE assessment_id = @assessment_id AND
							  component_name = @component_name )

	UPDATE components
		SET location = @location,
			component_num = @component_num,
			component_type = @component_type,
			assessment_obj = @assessment_obj
		WHERE component_name = @component_name
		AND   assessment_id = @assessment_id

	/* Update Connected Components and Criticalities */	
	UPDATE conn_components
		SET 
			component_num = @component_num
		WHERE 
			( component_num = @oldCompNum  AND
			  assessment_id = @assessment_id  )

	UPDATE component_criticality
		SET 
			component_num = @component_num
		WHERE 
			( component_num = @oldCompNum  AND
			  assessment_id = @assessment_id  )

END