create procedure get_question_results_per_policy
(
    @assessment_id     varchar(100),
    @critical_major    integer
)
AS
SELECT  	
	assessment_question_responses.major_section AS major_section,
	assessment_question_responses.minor_section AS minor_section,
	assessment_question_responses.question_number AS question_number,
	assessment_question_responses.level1 AS level1,
	assessment_question_responses.level2 AS level2,
	assessment_question_responses.level3 AS level3,
	assessment_question_responses.level4 AS level4,
	assessment_question_responses.level5 AS level5,
        na
FROM 
  	assessment_question_responses 
	WHERE
	    assessment_question_responses.assessment_id   = @assessment_id
	AND
	    assessment_question_responses.major_section   = @critical_major
	AND NOT
	    assessment_question_responses.minor_section   = 0
	AND NOT
	    assessment_question_responses.question_number   = 0
GO