create procedure get_summary_question_results
(
    @assessment_id    varchar(100)
)
AS
SELECT  
	assessment_questions.question_text,	
	assessment_question_responses.major_section,
	assessment_question_responses.minor_section,
	assessment_question_responses.question_number,
	level1,
	level2,
	level3,
	level4,
	level5,
	rbdm,
	cmnts,
	ar,
        na,
	reviewer,
        completed,
	assessors.full_name
FROM 
(
	assessment_questions
INNER JOIN
  	assessment_question_responses 	
ON 
	assessment_question_responses.major_section = assessment_questions.major_section
AND
	assessment_question_responses.minor_section = assessment_questions.minor_section
AND
	assessment_question_responses.question_number = assessment_questions.question_number
)
INNER JOIN
	assessors
ON	    
	assessment_question_responses.assessment_id = assessors.assessment_id
AND
	assessment_question_responses.major_section = assessors.major_section
AND	
	assessment_question_responses.minor_section = assessors.minor_section
AND
	assessment_question_responses.question_number = assessors.question_number

WHERE 
    assessment_question_responses.assessment_id = @assessment_id
ORDER BY 
    assessment_question_responses.major_section,
    assessment_question_responses.minor_section,
    assessment_question_responses.question_number
GO